# Font Awesome Cheat C#
This repo contains code that can be used to generate Font Awesome unicodes for your c# projects like WPF, Xamarin and ASP

I have this need to use FA across my Xamarin and ASP apps which would save me from downloading images for every little thing. 
I found a site online that extracted codes from `https://fontawesome.com/cheatsheet` directly using Javascript. I tried it but it appears the site has changed. 

I quickly decided to create mine using a C# .Net Console Application and the HTMLAgility Nuget package.
Steps to recreate:
* Visit `https://fontawesome.com/cheatsheet`
* Inspect the source, locate the body, expand it, locate ```<div class="ph4 ph6-ns pv6 ph0-pr pv0-pr bg-white">``` minimize the it, right click, click copy.
* Add an html file to your project and set build to 'copy always' and paste the code into the file.

Browse the source to see the full codes.

            private static void Main(string[] args)
        {
            //Goto https://fontawesome.com/cheatsheet 
            //Inspect  the source, locate the body, expand it, locate <div class="ph4 ph6-ns pv6 ph0-pr pv0-pr bg-white"> minimize the it, right click, copy.
            //Add an html file to your project and set build to 'copy always' and paste the code into the file.
            string path = @"test.html";

            //Initializes the Variable to use
            HtmlDocument htmlDoc = new HtmlDocument();
            //load html into variable
            htmlDoc.Load(path);

            //Load the three sessions (solid, regular, brands ) into the var 
            HtmlNodeCollection htmlSessions = htmlDoc.DocumentNode.SelectNodes("//section");
            //Iterate through sessions to process.
            Console.WriteLine($@"public class FontAwesome");
            Console.WriteLine(@"{");
            foreach (HtmlNode session in htmlSessions)
            {
                Console.WriteLine($@"public static class {Processor.Edit(session.Id)}");
                Console.WriteLine(@"{");
                HtmlNodeCollection session_articles = session.SelectNodes("//article");
                foreach (HtmlNode article in session_articles)
                {

                    string title = article.Id;
                    HtmlNode dlNode = article.ChildNodes[1];
                    HtmlNode ddNode = dlNode.ChildNodes[5];
                    string unicode = ddNode.InnerText;
                    string output = $@" public static string {Processor.Edit(title)} = ""\u{unicode}"";"; //&#x
                    Console.WriteLine(output);
                }
                Console.WriteLine("}");
                Console.WriteLine("");
                Console.WriteLine("");
                Console.WriteLine("");
            }
            Console.WriteLine("}");
        }



Here is the output:

```
public class FontAwesome
{
    public static class Solid
    {
        public static string Ad = "\uf641";
        public static string Address_Book = "\uf2b9";
        public static string Address_Card = "\uf2bb";
        public static string Adjust = "\uf042";
        public static string Air_Freshener = "\uf5d0";
        public static string Align_Center = "\uf037";
        public static string Align_Justify = "\uf039";
        public static string Align_Left = "\uf036";
        public static string Align_Right = "\uf038";
        public static string Allergies = "\uf461";
        public static string Ambulance = "\uf0f9";
        public static string American_Sign_Language_Interpreting = "\uf2a3";
        public static string Anchor = "\uf13d";
        public static string Angle_Double_Down = "\uf103";
        public static string Angle_Double_Left = "\uf100";
        public static string Angle_Double_Right = "\uf101";
        public static string Angle_Double_Up = "\uf102";
        public static string Angle_Down = "\uf107";
        public static string Angle_Left = "\uf104";
        public static string Angle_Right = "\uf105";
        public static string Angle_Up = "\uf106";
        public static string Angry = "\uf556";
        public static string Ankh = "\uf644";
        public static string Apple_Alt = "\uf5d1";
        public static string Archive = "\uf187";
        public static string Archway = "\uf557";
        public static string Arrow_Alt_Circle_Down = "\uf358";
        public static string Arrow_Alt_Circle_Left = "\uf359";
        public static string Arrow_Alt_Circle_Right = "\uf35a";
        public static string Arrow_Alt_Circle_Up = "\uf35b";
        public static string Arrow_Circle_Down = "\uf0ab";
        public static string Arrow_Circle_Left = "\uf0a8";
        public static string Arrow_Circle_Right = "\uf0a9";
        public static string Arrow_Circle_Up = "\uf0aa";
        public static string Arrow_Down = "\uf063";
        public static string Arrow_Left = "\uf060";
        public static string Arrow_Right = "\uf061";
        public static string Arrow_Up = "\uf062";
        public static string Arrows_Alt = "\uf0b2";
        public static string Arrows_Alt_H = "\uf337";
        public static string Arrows_Alt_V = "\uf338";
        public static string Assistive_Listening_Systems = "\uf2a2";
        public static string Asterisk = "\uf069";
        public static string At = "\uf1fa";
        public static string Atlas = "\uf558";
        public static string Atom = "\uf5d2";
        public static string Audio_Description = "\uf29e";
        public static string Award = "\uf559";
        public static string Backspace = "\uf55a";
        public static string Backward = "\uf04a";
        public static string Balance_Scale = "\uf24e";
        public static string Ban = "\uf05e";
        public static string Band_Aid = "\uf462";
        public static string Barcode = "\uf02a";
        public static string Bars = "\uf0c9";
        public static string Baseball_Ball = "\uf433";
        public static string Basketball_Ball = "\uf434";
        public static string Bath = "\uf2cd";
        public static string Battery_Empty = "\uf244";
        public static string Battery_Full = "\uf240";
        public static string Battery_Half = "\uf242";
        public static string Battery_Quarter = "\uf243";
        public static string Battery_Three_Quarters = "\uf241";
        public static string Bed = "\uf236";
        public static string Beer = "\uf0fc";
        public static string Bell = "\uf0f3";
        public static string Bell_Slash = "\uf1f6";
        public static string Bezier_Curve = "\uf55b";
        public static string Bible = "\uf647";
        public static string Bicycle = "\uf206";
        public static string Binoculars = "\uf1e5";
        public static string Birthday_Cake = "\uf1fd";
        public static string Blender = "\uf517";
        public static string Blender_Phone = "\uf6b6";
        public static string Blind = "\uf29d";
        public static string Bold = "\uf032";
        public static string Bolt = "\uf0e7";
        public static string Bomb = "\uf1e2";
        public static string Bone = "\uf5d7";
        public static string Bong = "\uf55c";
        public static string Book = "\uf02d";
        public static string Book_Dead = "\uf6b7";
        public static string Book_Open = "\uf518";
        public static string Book_Reader = "\uf5da";
        public static string Bookmark = "\uf02e";
        public static string Bowling_Ball = "\uf436";
        public static string Box = "\uf466";
        public static string Box_Open = "\uf49e";
        public static string Boxes = "\uf468";
        public static string Braille = "\uf2a1";
        public static string Brain = "\uf5dc";
        public static string Briefcase = "\uf0b1";
        public static string Briefcase_Medical = "\uf469";
        public static string Broadcast_Tower = "\uf519";
        public static string Broom = "\uf51a";
        public static string Brush = "\uf55d";
        public static string Bug = "\uf188";
        public static string Building = "\uf1ad";
        public static string Bullhorn = "\uf0a1";
        public static string Bullseye = "\uf140";
        public static string Burn = "\uf46a";
        public static string Bus = "\uf207";
        public static string Bus_Alt = "\uf55e";
        public static string Business_Time = "\uf64a";
        public static string Calculator = "\uf1ec";
        public static string Calendar = "\uf133";
        public static string Calendar_Alt = "\uf073";
        public static string Calendar_Check = "\uf274";
        public static string Calendar_Minus = "\uf272";
        public static string Calendar_Plus = "\uf271";
        public static string Calendar_Times = "\uf273";
        public static string Camera = "\uf030";
        public static string Camera_Retro = "\uf083";
        public static string Campground = "\uf6bb";
        public static string Cannabis = "\uf55f";
        public static string Capsules = "\uf46b";
        public static string Car = "\uf1b9";
        public static string Car_Alt = "\uf5de";
        public static string Car_Battery = "\uf5df";
        public static string Car_Crash = "\uf5e1";
        public static string Car_Side = "\uf5e4";
        public static string Caret_Down = "\uf0d7";
        public static string Caret_Left = "\uf0d9";
        public static string Caret_Right = "\uf0da";
        public static string Caret_Square_Down = "\uf150";
        public static string Caret_Square_Left = "\uf191";
        public static string Caret_Square_Right = "\uf152";
        public static string Caret_Square_Up = "\uf151";
        public static string Caret_Up = "\uf0d8";
        public static string Cart_Arrow_Down = "\uf218";
        public static string Cart_Plus = "\uf217";
        public static string Cat = "\uf6be";
        public static string Certificate = "\uf0a3";
        public static string Chair = "\uf6c0";
        public static string Chalkboard = "\uf51b";
        public static string Chalkboard_Teacher = "\uf51c";
        public static string Charging_Station = "\uf5e7";
        public static string Chart_Area = "\uf1fe";
        public static string Chart_Bar = "\uf080";
        public static string Chart_Line = "\uf201";
        public static string Chart_Pie = "\uf200";
        public static string Check = "\uf00c";
        public static string Check_Circle = "\uf058";
        public static string Check_Double = "\uf560";
        public static string Check_Square = "\uf14a";
        public static string Chess = "\uf439";
        public static string Chess_Bishop = "\uf43a";
        public static string Chess_Board = "\uf43c";
        public static string Chess_King = "\uf43f";
        public static string Chess_Knight = "\uf441";
        public static string Chess_Pawn = "\uf443";
        public static string Chess_Queen = "\uf445";
        public static string Chess_Rook = "\uf447";
        public static string Chevron_Circle_Down = "\uf13a";
        public static string Chevron_Circle_Left = "\uf137";
        public static string Chevron_Circle_Right = "\uf138";
        public static string Chevron_Circle_Up = "\uf139";
        public static string Chevron_Down = "\uf078";
        public static string Chevron_Left = "\uf053";
        public static string Chevron_Right = "\uf054";
        public static string Chevron_Up = "\uf077";
        public static string Child = "\uf1ae";
        public static string Church = "\uf51d";
        public static string Circle = "\uf111";
        public static string Circle_Notch = "\uf1ce";
        public static string City = "\uf64f";
        public static string Clipboard = "\uf328";
        public static string Clipboard_Check = "\uf46c";
        public static string Clipboard_List = "\uf46d";
        public static string Clock = "\uf017";
        public static string Clone = "\uf24d";
        public static string Closed_Captioning = "\uf20a";
        public static string Cloud = "\uf0c2";
        public static string Cloud_Download_Alt = "\uf381";
        public static string Cloud_Moon = "\uf6c3";
        public static string Cloud_Sun = "\uf6c4";
        public static string Cloud_Upload_Alt = "\uf382";
        public static string Cocktail = "\uf561";
        public static string Code = "\uf121";
        public static string Code_Branch = "\uf126";
        public static string Coffee = "\uf0f4";
        public static string Cog = "\uf013";
        public static string Cogs = "\uf085";
        public static string Coins = "\uf51e";
        public static string Columns = "\uf0db";
        public static string Comment = "\uf075";
        public static string Comment_Alt = "\uf27a";
        public static string Comment_Dollar = "\uf651";
        public static string Comment_Dots = "\uf4ad";
        public static string Comment_Slash = "\uf4b3";
        public static string Comments = "\uf086";
        public static string Comments_Dollar = "\uf653";
        public static string Compact_Disc = "\uf51f";
        public static string Compass = "\uf14e";
        public static string Compress = "\uf066";
        public static string Concierge_Bell = "\uf562";
        public static string Cookie = "\uf563";
        public static string Cookie_Bite = "\uf564";
        public static string Copy = "\uf0c5";
        public static string Copyright = "\uf1f9";
        public static string Couch = "\uf4b8";
        public static string Credit_Card = "\uf09d";
        public static string Crop = "\uf125";
        public static string Crop_Alt = "\uf565";
        public static string Cross = "\uf654";
        public static string Crosshairs = "\uf05b";
        public static string Crow = "\uf520";
        public static string Crown = "\uf521";
        public static string Cube = "\uf1b2";
        public static string Cubes = "\uf1b3";
        public static string Cut = "\uf0c4";
        public static string Database = "\uf1c0";
        public static string Deaf = "\uf2a4";
        public static string Desktop = "\uf108";
        public static string Dharmachakra = "\uf655";
        public static string Diagnoses = "\uf470";
        public static string Dice = "\uf522";
        public static string Dice_D20 = "\uf6cf";
        public static string Dice_D6 = "\uf6d1";
        public static string Dice_Five = "\uf523";
        public static string Dice_Four = "\uf524";
        public static string Dice_One = "\uf525";
        public static string Dice_Six = "\uf526";
        public static string Dice_Three = "\uf527";
        public static string Dice_Two = "\uf528";
        public static string Digital_Tachograph = "\uf566";
        public static string Directions = "\uf5eb";
        public static string Divide = "\uf529";
        public static string Dizzy = "\uf567";
        public static string Dna = "\uf471";
        public static string Dog = "\uf6d3";
        public static string Dollar_Sign = "\uf155";
        public static string Dolly = "\uf472";
        public static string Dolly_Flatbed = "\uf474";
        public static string Donate = "\uf4b9";
        public static string Door_Closed = "\uf52a";
        public static string Door_Open = "\uf52b";
        public static string Dot_Circle = "\uf192";
        public static string Dove = "\uf4ba";
        public static string Download = "\uf019";
        public static string Drafting_Compass = "\uf568";
        public static string Dragon = "\uf6d5";
        public static string Draw_Polygon = "\uf5ee";
        public static string Drum = "\uf569";
        public static string Drum_Steelpan = "\uf56a";
        public static string Drumstick_Bite = "\uf6d7";
        public static string Dumbbell = "\uf44b";
        public static string Dungeon = "\uf6d9";
        public static string Edit = "\uf044";
        public static string Eject = "\uf052";
        public static string Ellipsis_H = "\uf141";
        public static string Ellipsis_V = "\uf142";
        public static string Envelope = "\uf0e0";
        public static string Envelope_Open = "\uf2b6";
        public static string Envelope_Open_Text = "\uf658";
        public static string Envelope_Square = "\uf199";
        public static string Equals = "\uf52c";
        public static string Eraser = "\uf12d";
        public static string Euro_Sign = "\uf153";
        public static string Exchange_Alt = "\uf362";
        public static string Exclamation = "\uf12a";
        public static string Exclamation_Circle = "\uf06a";
        public static string Exclamation_Triangle = "\uf071";
        public static string Expand = "\uf065";
        public static string Expand_Arrows_Alt = "\uf31e";
        public static string External_Link_Alt = "\uf35d";
        public static string External_Link_Square_Alt = "\uf360";
        public static string Eye = "\uf06e";
        public static string Eye_Dropper = "\uf1fb";
        public static string Eye_Slash = "\uf070";
        public static string Fast_Backward = "\uf049";
        public static string Fast_Forward = "\uf050";
        public static string Fax = "\uf1ac";
        public static string Feather = "\uf52d";
        public static string Feather_Alt = "\uf56b";
        public static string Female = "\uf182";
        public static string Fighter_Jet = "\uf0fb";
        public static string File = "\uf15b";
        public static string File_Alt = "\uf15c";
        public static string File_Archive = "\uf1c6";
        public static string File_Audio = "\uf1c7";
        public static string File_Code = "\uf1c9";
        public static string File_Contract = "\uf56c";
        public static string File_Csv = "\uf6dd";
        public static string File_Download = "\uf56d";
        public static string File_Excel = "\uf1c3";
        public static string File_Export = "\uf56e";
        public static string File_Image = "\uf1c5";
        public static string File_Import = "\uf56f";
        public static string File_Invoice = "\uf570";
        public static string File_Invoice_Dollar = "\uf571";
        public static string File_Medical = "\uf477";
        public static string File_Medical_Alt = "\uf478";
        public static string File_Pdf = "\uf1c1";
        public static string File_Powerpoint = "\uf1c4";
        public static string File_Prescription = "\uf572";
        public static string File_Signature = "\uf573";
        public static string File_Upload = "\uf574";
        public static string File_Video = "\uf1c8";
        public static string File_Word = "\uf1c2";
        public static string Fill = "\uf575";
        public static string Fill_Drip = "\uf576";
        public static string Film = "\uf008";
        public static string Filter = "\uf0b0";
        public static string Fingerprint = "\uf577";
        public static string Fire = "\uf06d";
        public static string Fire_Extinguisher = "\uf134";
        public static string First_Aid = "\uf479";
        public static string Fish = "\uf578";
        public static string Fist_Raised = "\uf6de";
        public static string Flag = "\uf024";
        public static string Flag_Checkered = "\uf11e";
        public static string Flask = "\uf0c3";
        public static string Flushed = "\uf579";
        public static string Folder = "\uf07b";
        public static string Folder_Minus = "\uf65d";
        public static string Folder_Open = "\uf07c";
        public static string Folder_Plus = "\uf65e";
        public static string Font = "\uf031";
        public static string Font_Awesome_Logo_Full = "\uf4e6";
        public static string Football_Ball = "\uf44e";
        public static string Forward = "\uf04e";
        public static string Frog = "\uf52e";
        public static string Frown = "\uf119";
        public static string Frown_Open = "\uf57a";
        public static string Funnel_Dollar = "\uf662";
        public static string Futbol = "\uf1e3";
        public static string Gamepad = "\uf11b";
        public static string Gas_Pump = "\uf52f";
        public static string Gavel = "\uf0e3";
        public static string Gem = "\uf3a5";
        public static string Genderless = "\uf22d";
        public static string Ghost = "\uf6e2";
        public static string Gift = "\uf06b";
        public static string Glass_Martini = "\uf000";
        public static string Glass_Martini_Alt = "\uf57b";
        public static string Glasses = "\uf530";
        public static string Globe = "\uf0ac";
        public static string Globe_Africa = "\uf57c";
        public static string Globe_Americas = "\uf57d";
        public static string Globe_Asia = "\uf57e";
        public static string Golf_Ball = "\uf450";
        public static string Gopuram = "\uf664";
        public static string Graduation_Cap = "\uf19d";
        public static string Greater_Than = "\uf531";
        public static string Greater_Than_Equal = "\uf532";
        public static string Grimace = "\uf57f";
        public static string Grin = "\uf580";
        public static string Grin_Alt = "\uf581";
        public static string Grin_Beam = "\uf582";
        public static string Grin_Beam_Sweat = "\uf583";
        public static string Grin_Hearts = "\uf584";
        public static string Grin_Squint = "\uf585";
        public static string Grin_Squint_Tears = "\uf586";
        public static string Grin_Stars = "\uf587";
        public static string Grin_Tears = "\uf588";
        public static string Grin_Tongue = "\uf589";
        public static string Grin_Tongue_Squint = "\uf58a";
        public static string Grin_Tongue_Wink = "\uf58b";
        public static string Grin_Wink = "\uf58c";
        public static string Grip_Horizontal = "\uf58d";
        public static string Grip_Vertical = "\uf58e";
        public static string H_Square = "\uf0fd";
        public static string Hammer = "\uf6e3";
        public static string Hamsa = "\uf665";
        public static string Hand_Holding = "\uf4bd";
        public static string Hand_Holding_Heart = "\uf4be";
        public static string Hand_Holding_Usd = "\uf4c0";
        public static string Hand_Lizard = "\uf258";
        public static string Hand_Paper = "\uf256";
        public static string Hand_Peace = "\uf25b";
        public static string Hand_Point_Down = "\uf0a7";
        public static string Hand_Point_Left = "\uf0a5";
        public static string Hand_Point_Right = "\uf0a4";
        public static string Hand_Point_Up = "\uf0a6";
        public static string Hand_Pointer = "\uf25a";
        public static string Hand_Rock = "\uf255";
        public static string Hand_Scissors = "\uf257";
        public static string Hand_Spock = "\uf259";
        public static string Hands = "\uf4c2";
        public static string Hands_Helping = "\uf4c4";
        public static string Handshake = "\uf2b5";
        public static string Hanukiah = "\uf6e6";
        public static string Hashtag = "\uf292";
        public static string Hat_Wizard = "\uf6e8";
        public static string Haykal = "\uf666";
        public static string Hdd = "\uf0a0";
        public static string Heading = "\uf1dc";
        public static string Headphones = "\uf025";
        public static string Headphones_Alt = "\uf58f";
        public static string Headset = "\uf590";
        public static string Heart = "\uf004";
        public static string Heartbeat = "\uf21e";
        public static string Helicopter = "\uf533";
        public static string Highlighter = "\uf591";
        public static string Hiking = "\uf6ec";
        public static string Hippo = "\uf6ed";
        public static string History = "\uf1da";
        public static string Hockey_Puck = "\uf453";
        public static string Home = "\uf015";
        public static string Horse = "\uf6f0";
        public static string Hospital = "\uf0f8";
        public static string Hospital_Alt = "\uf47d";
        public static string Hospital_Symbol = "\uf47e";
        public static string Hot_Tub = "\uf593";
        public static string Hotel = "\uf594";
        public static string Hourglass = "\uf254";
        public static string Hourglass_End = "\uf253";
        public static string Hourglass_Half = "\uf252";
        public static string Hourglass_Start = "\uf251";
        public static string House_Damage = "\uf6f1";
        public static string Hryvnia = "\uf6f2";
        public static string I_Cursor = "\uf246";
        public static string Id_Badge = "\uf2c1";
        public static string Id_Card = "\uf2c2";
        public static string Id_Card_Alt = "\uf47f";
        public static string Image = "\uf03e";
        public static string Images = "\uf302";
        public static string Inbox = "\uf01c";
        public static string Indent = "\uf03c";
        public static string Industry = "\uf275";
        public static string Infinity = "\uf534";
        public static string Info = "\uf129";
        public static string Info_Circle = "\uf05a";
        public static string Italic = "\uf033";
        public static string Jedi = "\uf669";
        public static string Joint = "\uf595";
        public static string Journal_Whills = "\uf66a";
        public static string Kaaba = "\uf66b";
        public static string Key = "\uf084";
        public static string Keyboard = "\uf11c";
        public static string Khanda = "\uf66d";
        public static string Kiss = "\uf596";
        public static string Kiss_Beam = "\uf597";
        public static string Kiss_Wink_Heart = "\uf598";
        public static string Kiwi_Bird = "\uf535";
        public static string Landmark = "\uf66f";
        public static string Language = "\uf1ab";
        public static string Laptop = "\uf109";
        public static string Laptop_Code = "\uf5fc";
        public static string Laugh = "\uf599";
        public static string Laugh_Beam = "\uf59a";
        public static string Laugh_Squint = "\uf59b";
        public static string Laugh_Wink = "\uf59c";
        public static string Layer_Group = "\uf5fd";
        public static string Leaf = "\uf06c";
        public static string Lemon = "\uf094";
        public static string Less_Than = "\uf536";
        public static string Less_Than_Equal = "\uf537";
        public static string Level_Down_Alt = "\uf3be";
        public static string Level_Up_Alt = "\uf3bf";
        public static string Life_Ring = "\uf1cd";
        public static string Lightbulb = "\uf0eb";
        public static string Link = "\uf0c1";
        public static string Lira_Sign = "\uf195";
        public static string List = "\uf03a";
        public static string List_Alt = "\uf022";
        public static string List_Ol = "\uf0cb";
        public static string List_Ul = "\uf0ca";
        public static string Location_Arrow = "\uf124";
        public static string Lock = "\uf023";
        public static string Lock_Open = "\uf3c1";
        public static string Long_Arrow_Alt_Down = "\uf309";
        public static string Long_Arrow_Alt_Left = "\uf30a";
        public static string Long_Arrow_Alt_Right = "\uf30b";
        public static string Long_Arrow_Alt_Up = "\uf30c";
        public static string Low_Vision = "\uf2a8";
        public static string Luggage_Cart = "\uf59d";
        public static string Magic = "\uf0d0";
        public static string Magnet = "\uf076";
        public static string Mail_Bulk = "\uf674";
        public static string Male = "\uf183";
        public static string Map = "\uf279";
        public static string Map_Marked = "\uf59f";
        public static string Map_Marked_Alt = "\uf5a0";
        public static string Map_Marker = "\uf041";
        public static string Map_Marker_Alt = "\uf3c5";
        public static string Map_Pin = "\uf276";
        public static string Map_Signs = "\uf277";
        public static string Marker = "\uf5a1";
        public static string Mars = "\uf222";
        public static string Mars_Double = "\uf227";
        public static string Mars_Stroke = "\uf229";
        public static string Mars_Stroke_H = "\uf22b";
        public static string Mars_Stroke_V = "\uf22a";
        public static string Mask = "\uf6fa";
        public static string Medal = "\uf5a2";
        public static string Medkit = "\uf0fa";
        public static string Meh = "\uf11a";
        public static string Meh_Blank = "\uf5a4";
        public static string Meh_Rolling_Eyes = "\uf5a5";
        public static string Memory = "\uf538";
        public static string Menorah = "\uf676";
        public static string Mercury = "\uf223";
        public static string Microchip = "\uf2db";
        public static string Microphone = "\uf130";
        public static string Microphone_Alt = "\uf3c9";
        public static string Microphone_Alt_Slash = "\uf539";
        public static string Microphone_Slash = "\uf131";
        public static string Microscope = "\uf610";
        public static string Minus = "\uf068";
        public static string Minus_Circle = "\uf056";
        public static string Minus_Square = "\uf146";
        public static string Mobile = "\uf10b";
        public static string Mobile_Alt = "\uf3cd";
        public static string Money_Bill = "\uf0d6";
        public static string Money_Bill_Alt = "\uf3d1";
        public static string Money_Bill_Wave = "\uf53a";
        public static string Money_Bill_Wave_Alt = "\uf53b";
        public static string Money_Check = "\uf53c";
        public static string Money_Check_Alt = "\uf53d";
        public static string Monument = "\uf5a6";
        public static string Moon = "\uf186";
        public static string Mortar_Pestle = "\uf5a7";
        public static string Mosque = "\uf678";
        public static string Motorcycle = "\uf21c";
        public static string Mountain = "\uf6fc";
        public static string Mouse_Pointer = "\uf245";
        public static string Music = "\uf001";
        public static string Network_Wired = "\uf6ff";
        public static string Neuter = "\uf22c";
        public static string Newspaper = "\uf1ea";
        public static string Not_Equal = "\uf53e";
        public static string Notes_Medical = "\uf481";
        public static string Object_Group = "\uf247";
        public static string Object_Ungroup = "\uf248";
        public static string Oil_Can = "\uf613";
        public static string Om = "\uf679";
        public static string Otter = "\uf700";
        public static string Outdent = "\uf03b";
        public static string Paint_Brush = "\uf1fc";
        public static string Paint_Roller = "\uf5aa";
        public static string Palette = "\uf53f";
        public static string Pallet = "\uf482";
        public static string Paper_Plane = "\uf1d8";
        public static string Paperclip = "\uf0c6";
        public static string Parachute_Box = "\uf4cd";
        public static string Paragraph = "\uf1dd";
        public static string Parking = "\uf540";
        public static string Passport = "\uf5ab";
        public static string Pastafarianism = "\uf67b";
        public static string Paste = "\uf0ea";
        public static string Pause = "\uf04c";
        public static string Pause_Circle = "\uf28b";
        public static string Paw = "\uf1b0";
        public static string Peace = "\uf67c";
        public static string Pen = "\uf304";
        public static string Pen_Alt = "\uf305";
        public static string Pen_Fancy = "\uf5ac";
        public static string Pen_Nib = "\uf5ad";
        public static string Pen_Square = "\uf14b";
        public static string Pencil_Alt = "\uf303";
        public static string Pencil_Ruler = "\uf5ae";
        public static string People_Carry = "\uf4ce";
        public static string Percent = "\uf295";
        public static string Percentage = "\uf541";
        public static string Phone = "\uf095";
        public static string Phone_Slash = "\uf3dd";
        public static string Phone_Square = "\uf098";
        public static string Phone_Volume = "\uf2a0";
        public static string Piggy_Bank = "\uf4d3";
        public static string Pills = "\uf484";
        public static string Place_Of_Worship = "\uf67f";
        public static string Plane = "\uf072";
        public static string Plane_Arrival = "\uf5af";
        public static string Plane_Departure = "\uf5b0";
        public static string Play = "\uf04b";
        public static string Play_Circle = "\uf144";
        public static string Plug = "\uf1e6";
        public static string Plus = "\uf067";
        public static string Plus_Circle = "\uf055";
        public static string Plus_Square = "\uf0fe";
        public static string Podcast = "\uf2ce";
        public static string Poll = "\uf681";
        public static string Poll_H = "\uf682";
        public static string Poo = "\uf2fe";
        public static string Poop = "\uf619";
        public static string Portrait = "\uf3e0";
        public static string Pound_Sign = "\uf154";
        public static string Power_Off = "\uf011";
        public static string Pray = "\uf683";
        public static string Praying_Hands = "\uf684";
        public static string Prescription = "\uf5b1";
        public static string Prescription_Bottle = "\uf485";
        public static string Prescription_Bottle_Alt = "\uf486";
        public static string Print = "\uf02f";
        public static string Procedures = "\uf487";
        public static string Project_Diagram = "\uf542";
        public static string Puzzle_Piece = "\uf12e";
        public static string Qrcode = "\uf029";
        public static string Question = "\uf128";
        public static string Question_Circle = "\uf059";
        public static string Quidditch = "\uf458";
        public static string Quote_Left = "\uf10d";
        public static string Quote_Right = "\uf10e";
        public static string Quran = "\uf687";
        public static string Random = "\uf074";
        public static string Receipt = "\uf543";
        public static string Recycle = "\uf1b8";
        public static string Redo = "\uf01e";
        public static string Redo_Alt = "\uf2f9";
        public static string Registered = "\uf25d";
        public static string Reply = "\uf3e5";
        public static string Reply_All = "\uf122";
        public static string Retweet = "\uf079";
        public static string Ribbon = "\uf4d6";
        public static string Ring = "\uf70b";
        public static string Road = "\uf018";
        public static string Robot = "\uf544";
        public static string Rocket = "\uf135";
        public static string Route = "\uf4d7";
        public static string Rss = "\uf09e";
        public static string Rss_Square = "\uf143";
        public static string Ruble_Sign = "\uf158";
        public static string Ruler = "\uf545";
        public static string Ruler_Combined = "\uf546";
        public static string Ruler_Horizontal = "\uf547";
        public static string Ruler_Vertical = "\uf548";
        public static string Running = "\uf70c";
        public static string Rupee_Sign = "\uf156";
        public static string Sad_Cry = "\uf5b3";
        public static string Sad_Tear = "\uf5b4";
        public static string Save = "\uf0c7";
        public static string School = "\uf549";
        public static string Screwdriver = "\uf54a";
        public static string Scroll = "\uf70e";
        public static string Search = "\uf002";
        public static string Search_Dollar = "\uf688";
        public static string Search_Location = "\uf689";
        public static string Search_Minus = "\uf010";
        public static string Search_Plus = "\uf00e";
        public static string Seedling = "\uf4d8";
        public static string Server = "\uf233";
        public static string Shapes = "\uf61f";
        public static string Share = "\uf064";
        public static string Share_Alt = "\uf1e0";
        public static string Share_Alt_Square = "\uf1e1";
        public static string Share_Square = "\uf14d";
        public static string Shekel_Sign = "\uf20b";
        public static string Shield_Alt = "\uf3ed";
        public static string Ship = "\uf21a";
        public static string Shipping_Fast = "\uf48b";
        public static string Shoe_Prints = "\uf54b";
        public static string Shopping_Bag = "\uf290";
        public static string Shopping_Basket = "\uf291";
        public static string Shopping_Cart = "\uf07a";
        public static string Shower = "\uf2cc";
        public static string Shuttle_Van = "\uf5b6";
        public static string Sign = "\uf4d9";
        public static string Sign_In_Alt = "\uf2f6";
        public static string Sign_Language = "\uf2a7";
        public static string Sign_Out_Alt = "\uf2f5";
        public static string Signal = "\uf012";
        public static string Signature = "\uf5b7";
        public static string Sitemap = "\uf0e8";
        public static string Skull = "\uf54c";
        public static string Skull_Crossbones = "\uf714";
        public static string Slash = "\uf715";
        public static string Sliders_H = "\uf1de";
        public static string Smile = "\uf118";
        public static string Smile_Beam = "\uf5b8";
        public static string Smile_Wink = "\uf4da";
        public static string Smoking = "\uf48d";
        public static string Smoking_Ban = "\uf54d";
        public static string Snowflake = "\uf2dc";
        public static string Socks = "\uf696";
        public static string Solar_Panel = "\uf5ba";
        public static string Sort = "\uf0dc";
        public static string Sort_Alpha_Down = "\uf15d";
        public static string Sort_Alpha_Up = "\uf15e";
        public static string Sort_Amount_Down = "\uf160";
        public static string Sort_Amount_Up = "\uf161";
        public static string Sort_Down = "\uf0dd";
        public static string Sort_Numeric_Down = "\uf162";
        public static string Sort_Numeric_Up = "\uf163";
        public static string Sort_Up = "\uf0de";
        public static string Spa = "\uf5bb";
        public static string Space_Shuttle = "\uf197";
        public static string Spider = "\uf717";
        public static string Spinner = "\uf110";
        public static string Splotch = "\uf5bc";
        public static string Spray_Can = "\uf5bd";
        public static string Square = "\uf0c8";
        public static string Square_Full = "\uf45c";
        public static string Square_Root_Alt = "\uf698";
        public static string Stamp = "\uf5bf";
        public static string Star = "\uf005";
        public static string Star_And_Crescent = "\uf699";
        public static string Star_Half = "\uf089";
        public static string Star_Half_Alt = "\uf5c0";
        public static string Star_Of_David = "\uf69a";
        public static string Star_Of_Life = "\uf621";
        public static string Step_Backward = "\uf048";
        public static string Step_Forward = "\uf051";
        public static string Stethoscope = "\uf0f1";
        public static string Sticky_Note = "\uf249";
        public static string Stop = "\uf04d";
        public static string Stop_Circle = "\uf28d";
        public static string Stopwatch = "\uf2f2";
        public static string Store = "\uf54e";
        public static string Store_Alt = "\uf54f";
        public static string Stream = "\uf550";
        public static string Street_View = "\uf21d";
        public static string Strikethrough = "\uf0cc";
        public static string Stroopwafel = "\uf551";
        public static string Subscript = "\uf12c";
        public static string Subway = "\uf239";
        public static string Suitcase = "\uf0f2";
        public static string Suitcase_Rolling = "\uf5c1";
        public static string Sun = "\uf185";
        public static string Superscript = "\uf12b";
        public static string Surprise = "\uf5c2";
        public static string Swatchbook = "\uf5c3";
        public static string Swimmer = "\uf5c4";
        public static string Swimming_Pool = "\uf5c5";
        public static string Synagogue = "\uf69b";
        public static string Sync = "\uf021";
        public static string Sync_Alt = "\uf2f1";
        public static string Syringe = "\uf48e";
        public static string Table = "\uf0ce";
        public static string Table_Tennis = "\uf45d";
        public static string Tablet = "\uf10a";
        public static string Tablet_Alt = "\uf3fa";
        public static string Tablets = "\uf490";
        public static string Tachometer_Alt = "\uf3fd";
        public static string Tag = "\uf02b";
        public static string Tags = "\uf02c";
        public static string Tape = "\uf4db";
        public static string Tasks = "\uf0ae";
        public static string Taxi = "\uf1ba";
        public static string Teeth = "\uf62e";
        public static string Teeth_Open = "\uf62f";
        public static string Terminal = "\uf120";
        public static string Text_Height = "\uf034";
        public static string Text_Width = "\uf035";
        public static string Th = "\uf00a";
        public static string Th_Large = "\uf009";
        public static string Th_List = "\uf00b";
        public static string Theater_Masks = "\uf630";
        public static string Thermometer = "\uf491";
        public static string Thermometer_Empty = "\uf2cb";
        public static string Thermometer_Full = "\uf2c7";
        public static string Thermometer_Half = "\uf2c9";
        public static string Thermometer_Quarter = "\uf2ca";
        public static string Thermometer_Three_Quarters = "\uf2c8";
        public static string Thumbs_Down = "\uf165";
        public static string Thumbs_Up = "\uf164";
        public static string Thumbtack = "\uf08d";
        public static string Ticket_Alt = "\uf3ff";
        public static string Times = "\uf00d";
        public static string Times_Circle = "\uf057";
        public static string Tint = "\uf043";
        public static string Tint_Slash = "\uf5c7";
        public static string Tired = "\uf5c8";
        public static string Toggle_Off = "\uf204";
        public static string Toggle_On = "\uf205";
        public static string Toilet_Paper = "\uf71e";
        public static string Toolbox = "\uf552";
        public static string Tooth = "\uf5c9";
        public static string Torah = "\uf6a0";
        public static string Torii_Gate = "\uf6a1";
        public static string Tractor = "\uf722";
        public static string Trademark = "\uf25c";
        public static string Traffic_Light = "\uf637";
        public static string Train = "\uf238";
        public static string Transgender = "\uf224";
        public static string Transgender_Alt = "\uf225";
        public static string Trash = "\uf1f8";
        public static string Trash_Alt = "\uf2ed";
        public static string Tree = "\uf1bb";
        public static string Trophy = "\uf091";
        public static string Truck = "\uf0d1";
        public static string Truck_Loading = "\uf4de";
        public static string Truck_Monster = "\uf63b";
        public static string Truck_Moving = "\uf4df";
        public static string Truck_Pickup = "\uf63c";
        public static string Tshirt = "\uf553";
        public static string Tty = "\uf1e4";
        public static string Tv = "\uf26c";
        public static string Umbrella = "\uf0e9";
        public static string Umbrella_Beach = "\uf5ca";
        public static string Underline = "\uf0cd";
        public static string Undo = "\uf0e2";
        public static string Undo_Alt = "\uf2ea";
        public static string Universal_Access = "\uf29a";
        public static string University = "\uf19c";
        public static string Unlink = "\uf127";
        public static string Unlock = "\uf09c";
        public static string Unlock_Alt = "\uf13e";
        public static string Upload = "\uf093";
        public static string User = "\uf007";
        public static string User_Alt = "\uf406";
        public static string User_Alt_Slash = "\uf4fa";
        public static string User_Astronaut = "\uf4fb";
        public static string User_Check = "\uf4fc";
        public static string User_Circle = "\uf2bd";
        public static string User_Clock = "\uf4fd";
        public static string User_Cog = "\uf4fe";
        public static string User_Edit = "\uf4ff";
        public static string User_Friends = "\uf500";
        public static string User_Graduate = "\uf501";
        public static string User_Injured = "\uf728";
        public static string User_Lock = "\uf502";
        public static string User_Md = "\uf0f0";
        public static string User_Minus = "\uf503";
        public static string User_Ninja = "\uf504";
        public static string User_Plus = "\uf234";
        public static string User_Secret = "\uf21b";
        public static string User_Shield = "\uf505";
        public static string User_Slash = "\uf506";
        public static string User_Tag = "\uf507";
        public static string User_Tie = "\uf508";
        public static string User_Times = "\uf235";
        public static string Users = "\uf0c0";
        public static string Users_Cog = "\uf509";
        public static string Utensil_Spoon = "\uf2e5";
        public static string Utensils = "\uf2e7";
        public static string Vector_Square = "\uf5cb";
        public static string Venus = "\uf221";
        public static string Venus_Double = "\uf226";
        public static string Venus_Mars = "\uf228";
        public static string Vial = "\uf492";
        public static string Vials = "\uf493";
        public static string Video = "\uf03d";
        public static string Video_Slash = "\uf4e2";
        public static string Vihara = "\uf6a7";
        public static string Volleyball_Ball = "\uf45f";
        public static string Volume_Down = "\uf027";
        public static string Volume_Mute = "\uf6a9";
        public static string Volume_Off = "\uf026";
        public static string Volume_Up = "\uf028";
        public static string Walking = "\uf554";
        public static string Wallet = "\uf555";
        public static string Warehouse = "\uf494";
        public static string Weight = "\uf496";
        public static string Weight_Hanging = "\uf5cd";
        public static string Wheelchair = "\uf193";
        public static string Wifi = "\uf1eb";
        public static string Wind = "\uf72e";
        public static string Window_Close = "\uf410";
        public static string Window_Maximize = "\uf2d0";
        public static string Window_Minimize = "\uf2d1";
        public static string Window_Restore = "\uf2d2";
        public static string Wine_Bottle = "\uf72f";
        public static string Wine_Glass = "\uf4e3";
        public static string Wine_Glass_Alt = "\uf5ce";
        public static string Won_Sign = "\uf159";
        public static string Wrench = "\uf0ad";
        public static string X_Ray = "\uf497";
        public static string Yen_Sign = "\uf157";
        public static string Yin_Yang = "\uf6ad";
        public static string Address_Book = "\uf2b9";
        public static string Address_Card = "\uf2bb";
        public static string Angry = "\uf556";
        public static string Arrow_Alt_Circle_Down = "\uf358";
        public static string Arrow_Alt_Circle_Left = "\uf359";
        public static string Arrow_Alt_Circle_Right = "\uf35a";
        public static string Arrow_Alt_Circle_Up = "\uf35b";
        public static string Bell = "\uf0f3";
        public static string Bell_Slash = "\uf1f6";
        public static string Bookmark = "\uf02e";
        public static string Building = "\uf1ad";
        public static string Calendar = "\uf133";
        public static string Calendar_Alt = "\uf073";
        public static string Calendar_Check = "\uf274";
        public static string Calendar_Minus = "\uf272";
        public static string Calendar_Plus = "\uf271";
        public static string Calendar_Times = "\uf273";
        public static string Caret_Square_Down = "\uf150";
        public static string Caret_Square_Left = "\uf191";
        public static string Caret_Square_Right = "\uf152";
        public static string Caret_Square_Up = "\uf151";
        public static string Chart_Bar = "\uf080";
        public static string Check_Circle = "\uf058";
        public static string Check_Square = "\uf14a";
        public static string Circle = "\uf111";
        public static string Clipboard = "\uf328";
        public static string Clock = "\uf017";
        public static string Clone = "\uf24d";
        public static string Closed_Captioning = "\uf20a";
        public static string Comment = "\uf075";
        public static string Comment_Alt = "\uf27a";
        public static string Comment_Dots = "\uf4ad";
        public static string Comments = "\uf086";
        public static string Compass = "\uf14e";
        public static string Copy = "\uf0c5";
        public static string Copyright = "\uf1f9";
        public static string Credit_Card = "\uf09d";
        public static string Dizzy = "\uf567";
        public static string Dot_Circle = "\uf192";
        public static string Edit = "\uf044";
        public static string Envelope = "\uf0e0";
        public static string Envelope_Open = "\uf2b6";
        public static string Eye = "\uf06e";
        public static string Eye_Slash = "\uf070";
        public static string File = "\uf15b";
        public static string File_Alt = "\uf15c";
        public static string File_Archive = "\uf1c6";
        public static string File_Audio = "\uf1c7";
        public static string File_Code = "\uf1c9";
        public static string File_Excel = "\uf1c3";
        public static string File_Image = "\uf1c5";
        public static string File_Pdf = "\uf1c1";
        public static string File_Powerpoint = "\uf1c4";
        public static string File_Video = "\uf1c8";
        public static string File_Word = "\uf1c2";
        public static string Flag = "\uf024";
        public static string Flushed = "\uf579";
        public static string Folder = "\uf07b";
        public static string Folder_Open = "\uf07c";
        public static string Font_Awesome_Logo_Full = "\uf4e6";
        public static string Frown = "\uf119";
        public static string Frown_Open = "\uf57a";
        public static string Futbol = "\uf1e3";
        public static string Gem = "\uf3a5";
        public static string Grimace = "\uf57f";
        public static string Grin = "\uf580";
        public static string Grin_Alt = "\uf581";
        public static string Grin_Beam = "\uf582";
        public static string Grin_Beam_Sweat = "\uf583";
        public static string Grin_Hearts = "\uf584";
        public static string Grin_Squint = "\uf585";
        public static string Grin_Squint_Tears = "\uf586";
        public static string Grin_Stars = "\uf587";
        public static string Grin_Tears = "\uf588";
        public static string Grin_Tongue = "\uf589";
        public static string Grin_Tongue_Squint = "\uf58a";
        public static string Grin_Tongue_Wink = "\uf58b";
        public static string Grin_Wink = "\uf58c";
        public static string Hand_Lizard = "\uf258";
        public static string Hand_Paper = "\uf256";
        public static string Hand_Peace = "\uf25b";
        public static string Hand_Point_Down = "\uf0a7";
        public static string Hand_Point_Left = "\uf0a5";
        public static string Hand_Point_Right = "\uf0a4";
        public static string Hand_Point_Up = "\uf0a6";
        public static string Hand_Pointer = "\uf25a";
        public static string Hand_Rock = "\uf255";
        public static string Hand_Scissors = "\uf257";
        public static string Hand_Spock = "\uf259";
        public static string Handshake = "\uf2b5";
        public static string Hdd = "\uf0a0";
        public static string Heart = "\uf004";
        public static string Hospital = "\uf0f8";
        public static string Hourglass = "\uf254";
        public static string Id_Badge = "\uf2c1";
        public static string Id_Card = "\uf2c2";
        public static string Image = "\uf03e";
        public static string Images = "\uf302";
        public static string Keyboard = "\uf11c";
        public static string Kiss = "\uf596";
        public static string Kiss_Beam = "\uf597";
        public static string Kiss_Wink_Heart = "\uf598";
        public static string Laugh = "\uf599";
        public static string Laugh_Beam = "\uf59a";
        public static string Laugh_Squint = "\uf59b";
        public static string Laugh_Wink = "\uf59c";
        public static string Lemon = "\uf094";
        public static string Life_Ring = "\uf1cd";
        public static string Lightbulb = "\uf0eb";
        public static string List_Alt = "\uf022";
        public static string Map = "\uf279";
        public static string Meh = "\uf11a";
        public static string Meh_Blank = "\uf5a4";
        public static string Meh_Rolling_Eyes = "\uf5a5";
        public static string Minus_Square = "\uf146";
        public static string Money_Bill_Alt = "\uf3d1";
        public static string Moon = "\uf186";
        public static string Newspaper = "\uf1ea";
        public static string Object_Group = "\uf247";
        public static string Object_Ungroup = "\uf248";
        public static string Paper_Plane = "\uf1d8";
        public static string Pause_Circle = "\uf28b";
        public static string Play_Circle = "\uf144";
        public static string Plus_Square = "\uf0fe";
        public static string Question_Circle = "\uf059";
        public static string Registered = "\uf25d";
        public static string Sad_Cry = "\uf5b3";
        public static string Sad_Tear = "\uf5b4";
        public static string Save = "\uf0c7";
        public static string Share_Square = "\uf14d";
        public static string Smile = "\uf118";
        public static string Smile_Beam = "\uf5b8";
        public static string Smile_Wink = "\uf4da";
        public static string Snowflake = "\uf2dc";
        public static string Square = "\uf0c8";
        public static string Star = "\uf005";
        public static string Star_Half = "\uf089";
        public static string Sticky_Note = "\uf249";
        public static string Stop_Circle = "\uf28d";
        public static string Sun = "\uf185";
        public static string Surprise = "\uf5c2";
        public static string Thumbs_Down = "\uf165";
        public static string Thumbs_Up = "\uf164";
        public static string Times_Circle = "\uf057";
        public static string Tired = "\uf5c8";
        public static string Trash_Alt = "\uf2ed";
        public static string User = "\uf007";
        public static string User_Circle = "\uf2bd";
        public static string Window_Close = "\uf410";
        public static string Window_Maximize = "\uf2d0";
        public static string Window_Minimize = "\uf2d1";
        public static string Window_Restore = "\uf2d2";
        public static string Unknown59 = "\uf26e";
        public static string Accessible_Icon = "\uf368";
        public static string Accusoft = "\uf369";
        public static string Acquisitions_Incorporated = "\uf6af";
        public static string Adn = "\uf170";
        public static string Adversal = "\uf36a";
        public static string Affiliatetheme = "\uf36b";
        public static string Algolia = "\uf36c";
        public static string Alipay = "\uf642";
        public static string Amazon = "\uf270";
        public static string Amazon_Pay = "\uf42c";
        public static string Amilia = "\uf36d";
        public static string Android = "\uf17b";
        public static string Angellist = "\uf209";
        public static string Angrycreative = "\uf36e";
        public static string Angular = "\uf420";
        public static string App_Store = "\uf36f";
        public static string App_Store_Ios = "\uf370";
        public static string Apper = "\uf371";
        public static string Apple = "\uf179";
        public static string Apple_Pay = "\uf415";
        public static string Asymmetrik = "\uf372";
        public static string Audible = "\uf373";
        public static string Autoprefixer = "\uf41c";
        public static string Avianex = "\uf374";
        public static string Aviato = "\uf421";
        public static string Aws = "\uf375";
        public static string Bandcamp = "\uf2d5";
        public static string Behance = "\uf1b4";
        public static string Behance_Square = "\uf1b5";
        public static string Bimobject = "\uf378";
        public static string Bitbucket = "\uf171";
        public static string Bitcoin = "\uf379";
        public static string Bity = "\uf37a";
        public static string Black_Tie = "\uf27e";
        public static string Blackberry = "\uf37b";
        public static string Blogger = "\uf37c";
        public static string Blogger_B = "\uf37d";
        public static string Bluetooth = "\uf293";
        public static string Bluetooth_B = "\uf294";
        public static string Btc = "\uf15a";
        public static string Buromobelexperte = "\uf37f";
        public static string Buysellads = "\uf20d";
        public static string Cc_Amazon_Pay = "\uf42d";
        public static string Cc_Amex = "\uf1f3";
        public static string Cc_Apple_Pay = "\uf416";
        public static string Cc_Diners_Club = "\uf24c";
        public static string Cc_Discover = "\uf1f2";
        public static string Cc_Jcb = "\uf24b";
        public static string Cc_Mastercard = "\uf1f1";
        public static string Cc_Paypal = "\uf1f4";
        public static string Cc_Stripe = "\uf1f5";
        public static string Cc_Visa = "\uf1f0";
        public static string Centercode = "\uf380";
        public static string Chrome = "\uf268";
        public static string Cloudscale = "\uf383";
        public static string Cloudsmith = "\uf384";
        public static string Cloudversify = "\uf385";
        public static string Codepen = "\uf1cb";
        public static string Codiepie = "\uf284";
        public static string Connectdevelop = "\uf20e";
        public static string Contao = "\uf26d";
        public static string Cpanel = "\uf388";
        public static string Creative_Commons = "\uf25e";
        public static string Creative_Commons_By = "\uf4e7";
        public static string Creative_Commons_Nc = "\uf4e8";
        public static string Creative_Commons_Nc_Eu = "\uf4e9";
        public static string Creative_Commons_Nc_Jp = "\uf4ea";
        public static string Creative_Commons_Nd = "\uf4eb";
        public static string Creative_Commons_Pd = "\uf4ec";
        public static string Creative_Commons_Pd_Alt = "\uf4ed";
        public static string Creative_Commons_Remix = "\uf4ee";
        public static string Creative_Commons_Sa = "\uf4ef";
        public static string Creative_Commons_Sampling = "\uf4f0";
        public static string Creative_Commons_Sampling_Plus = "\uf4f1";
        public static string Creative_Commons_Share = "\uf4f2";
        public static string Creative_Commons_Zero = "\uf4f3";
        public static string Critical_Role = "\uf6c9";
        public static string Css3 = "\uf13c";
        public static string Css3_Alt = "\uf38b";
        public static string Cuttlefish = "\uf38c";
        public static string D_And_D = "\uf38d";
        public static string Dashcube = "\uf210";
        public static string Delicious = "\uf1a5";
        public static string Deploydog = "\uf38e";
        public static string Deskpro = "\uf38f";
        public static string Dev = "\uf6cc";
        public static string Deviantart = "\uf1bd";
        public static string Digg = "\uf1a6";
        public static string Digital_Ocean = "\uf391";
        public static string Discord = "\uf392";
        public static string Discourse = "\uf393";
        public static string Dochub = "\uf394";
        public static string Docker = "\uf395";
        public static string Draft2digital = "\uf396";
        public static string Dribbble = "\uf17d";
        public static string Dribbble_Square = "\uf397";
        public static string Dropbox = "\uf16b";
        public static string Drupal = "\uf1a9";
        public static string Dyalog = "\uf399";
        public static string Earlybirds = "\uf39a";
        public static string Ebay = "\uf4f4";
        public static string Edge = "\uf282";
        public static string Elementor = "\uf430";
        public static string Ello = "\uf5f1";
        public static string Ember = "\uf423";
        public static string Empire = "\uf1d1";
        public static string Envira = "\uf299";
        public static string Erlang = "\uf39d";
        public static string Ethereum = "\uf42e";
        public static string Etsy = "\uf2d7";
        public static string Expeditedssl = "\uf23e";
        public static string Facebook = "\uf09a";
        public static string Facebook_F = "\uf39e";
        public static string Facebook_Messenger = "\uf39f";
        public static string Facebook_Square = "\uf082";
        public static string Fantasy_Flight_Games = "\uf6dc";
        public static string Firefox = "\uf269";
        public static string First_Order = "\uf2b0";
        public static string First_Order_Alt = "\uf50a";
        public static string Firstdraft = "\uf3a1";
        public static string Flickr = "\uf16e";
        public static string Flipboard = "\uf44d";
        public static string Fly = "\uf417";
        public static string Font_Awesome = "\uf2b4";
        public static string Font_Awesome_Alt = "\uf35c";
        public static string Font_Awesome_Flag = "\uf425";
        public static string Font_Awesome_Logo_Full = "\uf4e6";
        public static string Fonticons = "\uf280";
        public static string Fonticons_Fi = "\uf3a2";
        public static string Fort_Awesome = "\uf286";
        public static string Fort_Awesome_Alt = "\uf3a3";
        public static string Forumbee = "\uf211";
        public static string Foursquare = "\uf180";
        public static string Free_Code_Camp = "\uf2c5";
        public static string Freebsd = "\uf3a4";
        public static string Fulcrum = "\uf50b";
        public static string Galactic_Republic = "\uf50c";
        public static string Galactic_Senate = "\uf50d";
        public static string Get_Pocket = "\uf265";
        public static string Gg = "\uf260";
        public static string Gg_Circle = "\uf261";
        public static string Git = "\uf1d3";
        public static string Git_Square = "\uf1d2";
        public static string Github = "\uf09b";
        public static string Github_Alt = "\uf113";
        public static string Github_Square = "\uf092";
        public static string Gitkraken = "\uf3a6";
        public static string Gitlab = "\uf296";
        public static string Gitter = "\uf426";
        public static string Glide = "\uf2a5";
        public static string Glide_G = "\uf2a6";
        public static string Gofore = "\uf3a7";
        public static string Goodreads = "\uf3a8";
        public static string Goodreads_G = "\uf3a9";
        public static string Google = "\uf1a0";
        public static string Google_Drive = "\uf3aa";
        public static string Google_Play = "\uf3ab";
        public static string Google_Plus = "\uf2b3";
        public static string Google_Plus_G = "\uf0d5";
        public static string Google_Plus_Square = "\uf0d4";
        public static string Google_Wallet = "\uf1ee";
        public static string Gratipay = "\uf184";
        public static string Grav = "\uf2d6";
        public static string Gripfire = "\uf3ac";
        public static string Grunt = "\uf3ad";
        public static string Gulp = "\uf3ae";
        public static string Hacker_News = "\uf1d4";
        public static string Hacker_News_Square = "\uf3af";
        public static string Hackerrank = "\uf5f7";
        public static string Hips = "\uf452";
        public static string Hire_A_Helper = "\uf3b0";
        public static string Hooli = "\uf427";
        public static string Hornbill = "\uf592";
        public static string Hotjar = "\uf3b1";
        public static string Houzz = "\uf27c";
        public static string Html5 = "\uf13b";
        public static string Hubspot = "\uf3b2";
        public static string Imdb = "\uf2d8";
        public static string Instagram = "\uf16d";
        public static string Internet_Explorer = "\uf26b";
        public static string Ioxhost = "\uf208";
        public static string Itunes = "\uf3b4";
        public static string Itunes_Note = "\uf3b5";
        public static string Java = "\uf4e4";
        public static string Jedi_Order = "\uf50e";
        public static string Jenkins = "\uf3b6";
        public static string Joget = "\uf3b7";
        public static string Joomla = "\uf1aa";
        public static string Js = "\uf3b8";
        public static string Js_Square = "\uf3b9";
        public static string Jsfiddle = "\uf1cc";
        public static string Kaggle = "\uf5fa";
        public static string Keybase = "\uf4f5";
        public static string Keycdn = "\uf3ba";
        public static string Kickstarter = "\uf3bb";
        public static string Kickstarter_K = "\uf3bc";
        public static string Korvue = "\uf42f";
        public static string Laravel = "\uf3bd";
        public static string Lastfm = "\uf202";
        public static string Lastfm_Square = "\uf203";
        public static string Leanpub = "\uf212";
        public static string Less = "\uf41d";
        public static string Line = "\uf3c0";
        public static string Linkedin = "\uf08c";
        public static string Linkedin_In = "\uf0e1";
        public static string Linode = "\uf2b8";
        public static string Linux = "\uf17c";
        public static string Lyft = "\uf3c3";
        public static string Magento = "\uf3c4";
        public static string Mailchimp = "\uf59e";
        public static string Mandalorian = "\uf50f";
        public static string Markdown = "\uf60f";
        public static string Mastodon = "\uf4f6";
        public static string Maxcdn = "\uf136";
        public static string Medapps = "\uf3c6";
        public static string Medium = "\uf23a";
        public static string Medium_M = "\uf3c7";
        public static string Medrt = "\uf3c8";
        public static string Meetup = "\uf2e0";
        public static string Megaport = "\uf5a3";
        public static string Microsoft = "\uf3ca";
        public static string Mix = "\uf3cb";
        public static string Mixcloud = "\uf289";
        public static string Mizuni = "\uf3cc";
        public static string Modx = "\uf285";
        public static string Monero = "\uf3d0";
        public static string Napster = "\uf3d2";
        public static string Neos = "\uf612";
        public static string Nimblr = "\uf5a8";
        public static string Nintendo_Switch = "\uf418";
        public static string Node = "\uf419";
        public static string Node_Js = "\uf3d3";
        public static string Npm = "\uf3d4";
        public static string Ns8 = "\uf3d5";
        public static string Nutritionix = "\uf3d6";
        public static string Odnoklassniki = "\uf263";
        public static string Odnoklassniki_Square = "\uf264";
        public static string Old_Republic = "\uf510";
        public static string Opencart = "\uf23d";
        public static string Openid = "\uf19b";
        public static string Opera = "\uf26a";
        public static string Optin_Monster = "\uf23c";
        public static string Osi = "\uf41a";
        public static string Page4 = "\uf3d7";
        public static string Pagelines = "\uf18c";
        public static string Palfed = "\uf3d8";
        public static string Patreon = "\uf3d9";
        public static string Paypal = "\uf1ed";
        public static string Penny_Arcade = "\uf704";
        public static string Periscope = "\uf3da";
        public static string Phabricator = "\uf3db";
        public static string Phoenix_Framework = "\uf3dc";
        public static string Phoenix_Squadron = "\uf511";
        public static string Php = "\uf457";
        public static string Pied_Piper = "\uf2ae";
        public static string Pied_Piper_Alt = "\uf1a8";
        public static string Pied_Piper_Hat = "\uf4e5";
        public static string Pied_Piper_Pp = "\uf1a7";
        public static string Pinterest = "\uf0d2";
        public static string Pinterest_P = "\uf231";
        public static string Pinterest_Square = "\uf0d3";
        public static string Playstation = "\uf3df";
        public static string Product_Hunt = "\uf288";
        public static string Pushed = "\uf3e1";
        public static string Python = "\uf3e2";
        public static string Qq = "\uf1d6";
        public static string Quinscape = "\uf459";
        public static string Quora = "\uf2c4";
        public static string R_Project = "\uf4f7";
        public static string Ravelry = "\uf2d9";
        public static string React = "\uf41b";
        public static string Readme = "\uf4d5";
        public static string Rebel = "\uf1d0";
        public static string Red_River = "\uf3e3";
        public static string Reddit = "\uf1a1";
        public static string Reddit_Alien = "\uf281";
        public static string Reddit_Square = "\uf1a2";
        public static string Rendact = "\uf3e4";
        public static string Renren = "\uf18b";
        public static string Replyd = "\uf3e6";
        public static string Researchgate = "\uf4f8";
        public static string Resolving = "\uf3e7";
        public static string Rev = "\uf5b2";
        public static string Rocketchat = "\uf3e8";
        public static string Rockrms = "\uf3e9";
        public static string Safari = "\uf267";
        public static string Sass = "\uf41e";
        public static string Schlix = "\uf3ea";
        public static string Scribd = "\uf28a";
        public static string Searchengin = "\uf3eb";
        public static string Sellcast = "\uf2da";
        public static string Sellsy = "\uf213";
        public static string Servicestack = "\uf3ec";
        public static string Shirtsinbulk = "\uf214";
        public static string Shopware = "\uf5b5";
        public static string Simplybuilt = "\uf215";
        public static string Sistrix = "\uf3ee";
        public static string Sith = "\uf512";
        public static string Skyatlas = "\uf216";
        public static string Skype = "\uf17e";
        public static string Slack = "\uf198";
        public static string Slack_Hash = "\uf3ef";
        public static string Slideshare = "\uf1e7";
        public static string Snapchat = "\uf2ab";
        public static string Snapchat_Ghost = "\uf2ac";
        public static string Snapchat_Square = "\uf2ad";
        public static string Soundcloud = "\uf1be";
        public static string Speakap = "\uf3f3";
        public static string Spotify = "\uf1bc";
        public static string Squarespace = "\uf5be";
        public static string Stack_Exchange = "\uf18d";
        public static string Stack_Overflow = "\uf16c";
        public static string Staylinked = "\uf3f5";
        public static string Steam = "\uf1b6";
        public static string Steam_Square = "\uf1b7";
        public static string Steam_Symbol = "\uf3f6";
        public static string Sticker_Mule = "\uf3f7";
        public static string Strava = "\uf428";
        public static string Stripe = "\uf429";
        public static string Stripe_S = "\uf42a";
        public static string Studiovinari = "\uf3f8";
        public static string Stumbleupon = "\uf1a4";
        public static string Stumbleupon_Circle = "\uf1a3";
        public static string Superpowers = "\uf2dd";
        public static string Supple = "\uf3f9";
        public static string Teamspeak = "\uf4f9";
        public static string Telegram = "\uf2c6";
        public static string Telegram_Plane = "\uf3fe";
        public static string Tencent_Weibo = "\uf1d5";
        public static string The_Red_Yeti = "\uf69d";
        public static string Themeco = "\uf5c6";
        public static string Themeisle = "\uf2b2";
        public static string Trade_Federation = "\uf513";
        public static string Trello = "\uf181";
        public static string Tripadvisor = "\uf262";
        public static string Tumblr = "\uf173";
        public static string Tumblr_Square = "\uf174";
        public static string Twitch = "\uf1e8";
        public static string Twitter = "\uf099";
        public static string Twitter_Square = "\uf081";
        public static string Typo3 = "\uf42b";
        public static string Uber = "\uf402";
        public static string Uikit = "\uf403";
        public static string Uniregistry = "\uf404";
        public static string Untappd = "\uf405";
        public static string Usb = "\uf287";
        public static string Ussunnah = "\uf407";
        public static string Vaadin = "\uf408";
        public static string Viacoin = "\uf237";
        public static string Viadeo = "\uf2a9";
        public static string Viadeo_Square = "\uf2aa";
        public static string Viber = "\uf409";
        public static string Vimeo = "\uf40a";
        public static string Vimeo_Square = "\uf194";
        public static string Vimeo_V = "\uf27d";
        public static string Vine = "\uf1ca";
        public static string Vk = "\uf189";
        public static string Vnv = "\uf40b";
        public static string Vuejs = "\uf41f";
        public static string Weebly = "\uf5cc";
        public static string Weibo = "\uf18a";
        public static string Weixin = "\uf1d7";
        public static string Whatsapp = "\uf232";
        public static string Whatsapp_Square = "\uf40c";
        public static string Whmcs = "\uf40d";
        public static string Wikipedia_W = "\uf266";
        public static string Windows = "\uf17a";
        public static string Wix = "\uf5cf";
        public static string Wizards_Of_The_Coast = "\uf730";
        public static string Wolf_Pack_Battalion = "\uf514";
        public static string Wordpress = "\uf19a";
        public static string Wordpress_Simple = "\uf411";
        public static string Wpbeginner = "\uf297";
        public static string Wpexplorer = "\uf2de";
        public static string Wpforms = "\uf298";
        public static string Xbox = "\uf412";
        public static string Xing = "\uf168";
        public static string Xing_Square = "\uf169";
        public static string Y_Combinator = "\uf23b";
        public static string Yahoo = "\uf19e";
        public static string Yandex = "\uf413";
        public static string Yandex_International = "\uf414";
        public static string Yelp = "\uf1e9";
        public static string Yoast = "\uf2b1";
        public static string Youtube = "\uf167";
        public static string Youtube_Square = "\uf431";
        public static string Zhihu = "\uf63f";
    }



    public static class Regular
    {
        public static string Ad = "\uf641";
        public static string Address_Book = "\uf2b9";
        public static string Address_Card = "\uf2bb";
        public static string Adjust = "\uf042";
        public static string Air_Freshener = "\uf5d0";
        public static string Align_Center = "\uf037";
        public static string Align_Justify = "\uf039";
        public static string Align_Left = "\uf036";
        public static string Align_Right = "\uf038";
        public static string Allergies = "\uf461";
        public static string Ambulance = "\uf0f9";
        public static string American_Sign_Language_Interpreting = "\uf2a3";
        public static string Anchor = "\uf13d";
        public static string Angle_Double_Down = "\uf103";
        public static string Angle_Double_Left = "\uf100";
        public static string Angle_Double_Right = "\uf101";
        public static string Angle_Double_Up = "\uf102";
        public static string Angle_Down = "\uf107";
        public static string Angle_Left = "\uf104";
        public static string Angle_Right = "\uf105";
        public static string Angle_Up = "\uf106";
        public static string Angry = "\uf556";
        public static string Ankh = "\uf644";
        public static string Apple_Alt = "\uf5d1";
        public static string Archive = "\uf187";
        public static string Archway = "\uf557";
        public static string Arrow_Alt_Circle_Down = "\uf358";
        public static string Arrow_Alt_Circle_Left = "\uf359";
        public static string Arrow_Alt_Circle_Right = "\uf35a";
        public static string Arrow_Alt_Circle_Up = "\uf35b";
        public static string Arrow_Circle_Down = "\uf0ab";
        public static string Arrow_Circle_Left = "\uf0a8";
        public static string Arrow_Circle_Right = "\uf0a9";
        public static string Arrow_Circle_Up = "\uf0aa";
        public static string Arrow_Down = "\uf063";
        public static string Arrow_Left = "\uf060";
        public static string Arrow_Right = "\uf061";
        public static string Arrow_Up = "\uf062";
        public static string Arrows_Alt = "\uf0b2";
        public static string Arrows_Alt_H = "\uf337";
        public static string Arrows_Alt_V = "\uf338";
        public static string Assistive_Listening_Systems = "\uf2a2";
        public static string Asterisk = "\uf069";
        public static string At = "\uf1fa";
        public static string Atlas = "\uf558";
        public static string Atom = "\uf5d2";
        public static string Audio_Description = "\uf29e";
        public static string Award = "\uf559";
        public static string Backspace = "\uf55a";
        public static string Backward = "\uf04a";
        public static string Balance_Scale = "\uf24e";
        public static string Ban = "\uf05e";
        public static string Band_Aid = "\uf462";
        public static string Barcode = "\uf02a";
        public static string Bars = "\uf0c9";
        public static string Baseball_Ball = "\uf433";
        public static string Basketball_Ball = "\uf434";
        public static string Bath = "\uf2cd";
        public static string Battery_Empty = "\uf244";
        public static string Battery_Full = "\uf240";
        public static string Battery_Half = "\uf242";
        public static string Battery_Quarter = "\uf243";
        public static string Battery_Three_Quarters = "\uf241";
        public static string Bed = "\uf236";
        public static string Beer = "\uf0fc";
        public static string Bell = "\uf0f3";
        public static string Bell_Slash = "\uf1f6";
        public static string Bezier_Curve = "\uf55b";
        public static string Bible = "\uf647";
        public static string Bicycle = "\uf206";
        public static string Binoculars = "\uf1e5";
        public static string Birthday_Cake = "\uf1fd";
        public static string Blender = "\uf517";
        public static string Blender_Phone = "\uf6b6";
        public static string Blind = "\uf29d";
        public static string Bold = "\uf032";
        public static string Bolt = "\uf0e7";
        public static string Bomb = "\uf1e2";
        public static string Bone = "\uf5d7";
        public static string Bong = "\uf55c";
        public static string Book = "\uf02d";
        public static string Book_Dead = "\uf6b7";
        public static string Book_Open = "\uf518";
        public static string Book_Reader = "\uf5da";
        public static string Bookmark = "\uf02e";
        public static string Bowling_Ball = "\uf436";
        public static string Box = "\uf466";
        public static string Box_Open = "\uf49e";
        public static string Boxes = "\uf468";
        public static string Braille = "\uf2a1";
        public static string Brain = "\uf5dc";
        public static string Briefcase = "\uf0b1";
        public static string Briefcase_Medical = "\uf469";
        public static string Broadcast_Tower = "\uf519";
        public static string Broom = "\uf51a";
        public static string Brush = "\uf55d";
        public static string Bug = "\uf188";
        public static string Building = "\uf1ad";
        public static string Bullhorn = "\uf0a1";
        public static string Bullseye = "\uf140";
        public static string Burn = "\uf46a";
        public static string Bus = "\uf207";
        public static string Bus_Alt = "\uf55e";
        public static string Business_Time = "\uf64a";
        public static string Calculator = "\uf1ec";
        public static string Calendar = "\uf133";
        public static string Calendar_Alt = "\uf073";
        public static string Calendar_Check = "\uf274";
        public static string Calendar_Minus = "\uf272";
        public static string Calendar_Plus = "\uf271";
        public static string Calendar_Times = "\uf273";
        public static string Camera = "\uf030";
        public static string Camera_Retro = "\uf083";
        public static string Campground = "\uf6bb";
        public static string Cannabis = "\uf55f";
        public static string Capsules = "\uf46b";
        public static string Car = "\uf1b9";
        public static string Car_Alt = "\uf5de";
        public static string Car_Battery = "\uf5df";
        public static string Car_Crash = "\uf5e1";
        public static string Car_Side = "\uf5e4";
        public static string Caret_Down = "\uf0d7";
        public static string Caret_Left = "\uf0d9";
        public static string Caret_Right = "\uf0da";
        public static string Caret_Square_Down = "\uf150";
        public static string Caret_Square_Left = "\uf191";
        public static string Caret_Square_Right = "\uf152";
        public static string Caret_Square_Up = "\uf151";
        public static string Caret_Up = "\uf0d8";
        public static string Cart_Arrow_Down = "\uf218";
        public static string Cart_Plus = "\uf217";
        public static string Cat = "\uf6be";
        public static string Certificate = "\uf0a3";
        public static string Chair = "\uf6c0";
        public static string Chalkboard = "\uf51b";
        public static string Chalkboard_Teacher = "\uf51c";
        public static string Charging_Station = "\uf5e7";
        public static string Chart_Area = "\uf1fe";
        public static string Chart_Bar = "\uf080";
        public static string Chart_Line = "\uf201";
        public static string Chart_Pie = "\uf200";
        public static string Check = "\uf00c";
        public static string Check_Circle = "\uf058";
        public static string Check_Double = "\uf560";
        public static string Check_Square = "\uf14a";
        public static string Chess = "\uf439";
        public static string Chess_Bishop = "\uf43a";
        public static string Chess_Board = "\uf43c";
        public static string Chess_King = "\uf43f";
        public static string Chess_Knight = "\uf441";
        public static string Chess_Pawn = "\uf443";
        public static string Chess_Queen = "\uf445";
        public static string Chess_Rook = "\uf447";
        public static string Chevron_Circle_Down = "\uf13a";
        public static string Chevron_Circle_Left = "\uf137";
        public static string Chevron_Circle_Right = "\uf138";
        public static string Chevron_Circle_Up = "\uf139";
        public static string Chevron_Down = "\uf078";
        public static string Chevron_Left = "\uf053";
        public static string Chevron_Right = "\uf054";
        public static string Chevron_Up = "\uf077";
        public static string Child = "\uf1ae";
        public static string Church = "\uf51d";
        public static string Circle = "\uf111";
        public static string Circle_Notch = "\uf1ce";
        public static string City = "\uf64f";
        public static string Clipboard = "\uf328";
        public static string Clipboard_Check = "\uf46c";
        public static string Clipboard_List = "\uf46d";
        public static string Clock = "\uf017";
        public static string Clone = "\uf24d";
        public static string Closed_Captioning = "\uf20a";
        public static string Cloud = "\uf0c2";
        public static string Cloud_Download_Alt = "\uf381";
        public static string Cloud_Moon = "\uf6c3";
        public static string Cloud_Sun = "\uf6c4";
        public static string Cloud_Upload_Alt = "\uf382";
        public static string Cocktail = "\uf561";
        public static string Code = "\uf121";
        public static string Code_Branch = "\uf126";
        public static string Coffee = "\uf0f4";
        public static string Cog = "\uf013";
        public static string Cogs = "\uf085";
        public static string Coins = "\uf51e";
        public static string Columns = "\uf0db";
        public static string Comment = "\uf075";
        public static string Comment_Alt = "\uf27a";
        public static string Comment_Dollar = "\uf651";
        public static string Comment_Dots = "\uf4ad";
        public static string Comment_Slash = "\uf4b3";
        public static string Comments = "\uf086";
        public static string Comments_Dollar = "\uf653";
        public static string Compact_Disc = "\uf51f";
        public static string Compass = "\uf14e";
        public static string Compress = "\uf066";
        public static string Concierge_Bell = "\uf562";
        public static string Cookie = "\uf563";
        public static string Cookie_Bite = "\uf564";
        public static string Copy = "\uf0c5";
        public static string Copyright = "\uf1f9";
        public static string Couch = "\uf4b8";
        public static string Credit_Card = "\uf09d";
        public static string Crop = "\uf125";
        public static string Crop_Alt = "\uf565";
        public static string Cross = "\uf654";
        public static string Crosshairs = "\uf05b";
        public static string Crow = "\uf520";
        public static string Crown = "\uf521";
        public static string Cube = "\uf1b2";
        public static string Cubes = "\uf1b3";
        public static string Cut = "\uf0c4";
        public static string Database = "\uf1c0";
        public static string Deaf = "\uf2a4";
        public static string Desktop = "\uf108";
        public static string Dharmachakra = "\uf655";
        public static string Diagnoses = "\uf470";
        public static string Dice = "\uf522";
        public static string Dice_D20 = "\uf6cf";
        public static string Dice_D6 = "\uf6d1";
        public static string Dice_Five = "\uf523";
        public static string Dice_Four = "\uf524";
        public static string Dice_One = "\uf525";
        public static string Dice_Six = "\uf526";
        public static string Dice_Three = "\uf527";
        public static string Dice_Two = "\uf528";
        public static string Digital_Tachograph = "\uf566";
        public static string Directions = "\uf5eb";
        public static string Divide = "\uf529";
        public static string Dizzy = "\uf567";
        public static string Dna = "\uf471";
        public static string Dog = "\uf6d3";
        public static string Dollar_Sign = "\uf155";
        public static string Dolly = "\uf472";
        public static string Dolly_Flatbed = "\uf474";
        public static string Donate = "\uf4b9";
        public static string Door_Closed = "\uf52a";
        public static string Door_Open = "\uf52b";
        public static string Dot_Circle = "\uf192";
        public static string Dove = "\uf4ba";
        public static string Download = "\uf019";
        public static string Drafting_Compass = "\uf568";
        public static string Dragon = "\uf6d5";
        public static string Draw_Polygon = "\uf5ee";
        public static string Drum = "\uf569";
        public static string Drum_Steelpan = "\uf56a";
        public static string Drumstick_Bite = "\uf6d7";
        public static string Dumbbell = "\uf44b";
        public static string Dungeon = "\uf6d9";
        public static string Edit = "\uf044";
        public static string Eject = "\uf052";
        public static string Ellipsis_H = "\uf141";
        public static string Ellipsis_V = "\uf142";
        public static string Envelope = "\uf0e0";
        public static string Envelope_Open = "\uf2b6";
        public static string Envelope_Open_Text = "\uf658";
        public static string Envelope_Square = "\uf199";
        public static string Equals = "\uf52c";
        public static string Eraser = "\uf12d";
        public static string Euro_Sign = "\uf153";
        public static string Exchange_Alt = "\uf362";
        public static string Exclamation = "\uf12a";
        public static string Exclamation_Circle = "\uf06a";
        public static string Exclamation_Triangle = "\uf071";
        public static string Expand = "\uf065";
        public static string Expand_Arrows_Alt = "\uf31e";
        public static string External_Link_Alt = "\uf35d";
        public static string External_Link_Square_Alt = "\uf360";
        public static string Eye = "\uf06e";
        public static string Eye_Dropper = "\uf1fb";
        public static string Eye_Slash = "\uf070";
        public static string Fast_Backward = "\uf049";
        public static string Fast_Forward = "\uf050";
        public static string Fax = "\uf1ac";
        public static string Feather = "\uf52d";
        public static string Feather_Alt = "\uf56b";
        public static string Female = "\uf182";
        public static string Fighter_Jet = "\uf0fb";
        public static string File = "\uf15b";
        public static string File_Alt = "\uf15c";
        public static string File_Archive = "\uf1c6";
        public static string File_Audio = "\uf1c7";
        public static string File_Code = "\uf1c9";
        public static string File_Contract = "\uf56c";
        public static string File_Csv = "\uf6dd";
        public static string File_Download = "\uf56d";
        public static string File_Excel = "\uf1c3";
        public static string File_Export = "\uf56e";
        public static string File_Image = "\uf1c5";
        public static string File_Import = "\uf56f";
        public static string File_Invoice = "\uf570";
        public static string File_Invoice_Dollar = "\uf571";
        public static string File_Medical = "\uf477";
        public static string File_Medical_Alt = "\uf478";
        public static string File_Pdf = "\uf1c1";
        public static string File_Powerpoint = "\uf1c4";
        public static string File_Prescription = "\uf572";
        public static string File_Signature = "\uf573";
        public static string File_Upload = "\uf574";
        public static string File_Video = "\uf1c8";
        public static string File_Word = "\uf1c2";
        public static string Fill = "\uf575";
        public static string Fill_Drip = "\uf576";
        public static string Film = "\uf008";
        public static string Filter = "\uf0b0";
        public static string Fingerprint = "\uf577";
        public static string Fire = "\uf06d";
        public static string Fire_Extinguisher = "\uf134";
        public static string First_Aid = "\uf479";
        public static string Fish = "\uf578";
        public static string Fist_Raised = "\uf6de";
        public static string Flag = "\uf024";
        public static string Flag_Checkered = "\uf11e";
        public static string Flask = "\uf0c3";
        public static string Flushed = "\uf579";
        public static string Folder = "\uf07b";
        public static string Folder_Minus = "\uf65d";
        public static string Folder_Open = "\uf07c";
        public static string Folder_Plus = "\uf65e";
        public static string Font = "\uf031";
        public static string Font_Awesome_Logo_Full = "\uf4e6";
        public static string Football_Ball = "\uf44e";
        public static string Forward = "\uf04e";
        public static string Frog = "\uf52e";
        public static string Frown = "\uf119";
        public static string Frown_Open = "\uf57a";
        public static string Funnel_Dollar = "\uf662";
        public static string Futbol = "\uf1e3";
        public static string Gamepad = "\uf11b";
        public static string Gas_Pump = "\uf52f";
        public static string Gavel = "\uf0e3";
        public static string Gem = "\uf3a5";
        public static string Genderless = "\uf22d";
        public static string Ghost = "\uf6e2";
        public static string Gift = "\uf06b";
        public static string Glass_Martini = "\uf000";
        public static string Glass_Martini_Alt = "\uf57b";
        public static string Glasses = "\uf530";
        public static string Globe = "\uf0ac";
        public static string Globe_Africa = "\uf57c";
        public static string Globe_Americas = "\uf57d";
        public static string Globe_Asia = "\uf57e";
        public static string Golf_Ball = "\uf450";
        public static string Gopuram = "\uf664";
        public static string Graduation_Cap = "\uf19d";
        public static string Greater_Than = "\uf531";
        public static string Greater_Than_Equal = "\uf532";
        public static string Grimace = "\uf57f";
        public static string Grin = "\uf580";
        public static string Grin_Alt = "\uf581";
        public static string Grin_Beam = "\uf582";
        public static string Grin_Beam_Sweat = "\uf583";
        public static string Grin_Hearts = "\uf584";
        public static string Grin_Squint = "\uf585";
        public static string Grin_Squint_Tears = "\uf586";
        public static string Grin_Stars = "\uf587";
        public static string Grin_Tears = "\uf588";
        public static string Grin_Tongue = "\uf589";
        public static string Grin_Tongue_Squint = "\uf58a";
        public static string Grin_Tongue_Wink = "\uf58b";
        public static string Grin_Wink = "\uf58c";
        public static string Grip_Horizontal = "\uf58d";
        public static string Grip_Vertical = "\uf58e";
        public static string H_Square = "\uf0fd";
        public static string Hammer = "\uf6e3";
        public static string Hamsa = "\uf665";
        public static string Hand_Holding = "\uf4bd";
        public static string Hand_Holding_Heart = "\uf4be";
        public static string Hand_Holding_Usd = "\uf4c0";
        public static string Hand_Lizard = "\uf258";
        public static string Hand_Paper = "\uf256";
        public static string Hand_Peace = "\uf25b";
        public static string Hand_Point_Down = "\uf0a7";
        public static string Hand_Point_Left = "\uf0a5";
        public static string Hand_Point_Right = "\uf0a4";
        public static string Hand_Point_Up = "\uf0a6";
        public static string Hand_Pointer = "\uf25a";
        public static string Hand_Rock = "\uf255";
        public static string Hand_Scissors = "\uf257";
        public static string Hand_Spock = "\uf259";
        public static string Hands = "\uf4c2";
        public static string Hands_Helping = "\uf4c4";
        public static string Handshake = "\uf2b5";
        public static string Hanukiah = "\uf6e6";
        public static string Hashtag = "\uf292";
        public static string Hat_Wizard = "\uf6e8";
        public static string Haykal = "\uf666";
        public static string Hdd = "\uf0a0";
        public static string Heading = "\uf1dc";
        public static string Headphones = "\uf025";
        public static string Headphones_Alt = "\uf58f";
        public static string Headset = "\uf590";
        public static string Heart = "\uf004";
        public static string Heartbeat = "\uf21e";
        public static string Helicopter = "\uf533";
        public static string Highlighter = "\uf591";
        public static string Hiking = "\uf6ec";
        public static string Hippo = "\uf6ed";
        public static string History = "\uf1da";
        public static string Hockey_Puck = "\uf453";
        public static string Home = "\uf015";
        public static string Horse = "\uf6f0";
        public static string Hospital = "\uf0f8";
        public static string Hospital_Alt = "\uf47d";
        public static string Hospital_Symbol = "\uf47e";
        public static string Hot_Tub = "\uf593";
        public static string Hotel = "\uf594";
        public static string Hourglass = "\uf254";
        public static string Hourglass_End = "\uf253";
        public static string Hourglass_Half = "\uf252";
        public static string Hourglass_Start = "\uf251";
        public static string House_Damage = "\uf6f1";
        public static string Hryvnia = "\uf6f2";
        public static string I_Cursor = "\uf246";
        public static string Id_Badge = "\uf2c1";
        public static string Id_Card = "\uf2c2";
        public static string Id_Card_Alt = "\uf47f";
        public static string Image = "\uf03e";
        public static string Images = "\uf302";
        public static string Inbox = "\uf01c";
        public static string Indent = "\uf03c";
        public static string Industry = "\uf275";
        public static string Infinity = "\uf534";
        public static string Info = "\uf129";
        public static string Info_Circle = "\uf05a";
        public static string Italic = "\uf033";
        public static string Jedi = "\uf669";
        public static string Joint = "\uf595";
        public static string Journal_Whills = "\uf66a";
        public static string Kaaba = "\uf66b";
        public static string Key = "\uf084";
        public static string Keyboard = "\uf11c";
        public static string Khanda = "\uf66d";
        public static string Kiss = "\uf596";
        public static string Kiss_Beam = "\uf597";
        public static string Kiss_Wink_Heart = "\uf598";
        public static string Kiwi_Bird = "\uf535";
        public static string Landmark = "\uf66f";
        public static string Language = "\uf1ab";
        public static string Laptop = "\uf109";
        public static string Laptop_Code = "\uf5fc";
        public static string Laugh = "\uf599";
        public static string Laugh_Beam = "\uf59a";
        public static string Laugh_Squint = "\uf59b";
        public static string Laugh_Wink = "\uf59c";
        public static string Layer_Group = "\uf5fd";
        public static string Leaf = "\uf06c";
        public static string Lemon = "\uf094";
        public static string Less_Than = "\uf536";
        public static string Less_Than_Equal = "\uf537";
        public static string Level_Down_Alt = "\uf3be";
        public static string Level_Up_Alt = "\uf3bf";
        public static string Life_Ring = "\uf1cd";
        public static string Lightbulb = "\uf0eb";
        public static string Link = "\uf0c1";
        public static string Lira_Sign = "\uf195";
        public static string List = "\uf03a";
        public static string List_Alt = "\uf022";
        public static string List_Ol = "\uf0cb";
        public static string List_Ul = "\uf0ca";
        public static string Location_Arrow = "\uf124";
        public static string Lock = "\uf023";
        public static string Lock_Open = "\uf3c1";
        public static string Long_Arrow_Alt_Down = "\uf309";
        public static string Long_Arrow_Alt_Left = "\uf30a";
        public static string Long_Arrow_Alt_Right = "\uf30b";
        public static string Long_Arrow_Alt_Up = "\uf30c";
        public static string Low_Vision = "\uf2a8";
        public static string Luggage_Cart = "\uf59d";
        public static string Magic = "\uf0d0";
        public static string Magnet = "\uf076";
        public static string Mail_Bulk = "\uf674";
        public static string Male = "\uf183";
        public static string Map = "\uf279";
        public static string Map_Marked = "\uf59f";
        public static string Map_Marked_Alt = "\uf5a0";
        public static string Map_Marker = "\uf041";
        public static string Map_Marker_Alt = "\uf3c5";
        public static string Map_Pin = "\uf276";
        public static string Map_Signs = "\uf277";
        public static string Marker = "\uf5a1";
        public static string Mars = "\uf222";
        public static string Mars_Double = "\uf227";
        public static string Mars_Stroke = "\uf229";
        public static string Mars_Stroke_H = "\uf22b";
        public static string Mars_Stroke_V = "\uf22a";
        public static string Mask = "\uf6fa";
        public static string Medal = "\uf5a2";
        public static string Medkit = "\uf0fa";
        public static string Meh = "\uf11a";
        public static string Meh_Blank = "\uf5a4";
        public static string Meh_Rolling_Eyes = "\uf5a5";
        public static string Memory = "\uf538";
        public static string Menorah = "\uf676";
        public static string Mercury = "\uf223";
        public static string Microchip = "\uf2db";
        public static string Microphone = "\uf130";
        public static string Microphone_Alt = "\uf3c9";
        public static string Microphone_Alt_Slash = "\uf539";
        public static string Microphone_Slash = "\uf131";
        public static string Microscope = "\uf610";
        public static string Minus = "\uf068";
        public static string Minus_Circle = "\uf056";
        public static string Minus_Square = "\uf146";
        public static string Mobile = "\uf10b";
        public static string Mobile_Alt = "\uf3cd";
        public static string Money_Bill = "\uf0d6";
        public static string Money_Bill_Alt = "\uf3d1";
        public static string Money_Bill_Wave = "\uf53a";
        public static string Money_Bill_Wave_Alt = "\uf53b";
        public static string Money_Check = "\uf53c";
        public static string Money_Check_Alt = "\uf53d";
        public static string Monument = "\uf5a6";
        public static string Moon = "\uf186";
        public static string Mortar_Pestle = "\uf5a7";
        public static string Mosque = "\uf678";
        public static string Motorcycle = "\uf21c";
        public static string Mountain = "\uf6fc";
        public static string Mouse_Pointer = "\uf245";
        public static string Music = "\uf001";
        public static string Network_Wired = "\uf6ff";
        public static string Neuter = "\uf22c";
        public static string Newspaper = "\uf1ea";
        public static string Not_Equal = "\uf53e";
        public static string Notes_Medical = "\uf481";
        public static string Object_Group = "\uf247";
        public static string Object_Ungroup = "\uf248";
        public static string Oil_Can = "\uf613";
        public static string Om = "\uf679";
        public static string Otter = "\uf700";
        public static string Outdent = "\uf03b";
        public static string Paint_Brush = "\uf1fc";
        public static string Paint_Roller = "\uf5aa";
        public static string Palette = "\uf53f";
        public static string Pallet = "\uf482";
        public static string Paper_Plane = "\uf1d8";
        public static string Paperclip = "\uf0c6";
        public static string Parachute_Box = "\uf4cd";
        public static string Paragraph = "\uf1dd";
        public static string Parking = "\uf540";
        public static string Passport = "\uf5ab";
        public static string Pastafarianism = "\uf67b";
        public static string Paste = "\uf0ea";
        public static string Pause = "\uf04c";
        public static string Pause_Circle = "\uf28b";
        public static string Paw = "\uf1b0";
        public static string Peace = "\uf67c";
        public static string Pen = "\uf304";
        public static string Pen_Alt = "\uf305";
        public static string Pen_Fancy = "\uf5ac";
        public static string Pen_Nib = "\uf5ad";
        public static string Pen_Square = "\uf14b";
        public static string Pencil_Alt = "\uf303";
        public static string Pencil_Ruler = "\uf5ae";
        public static string People_Carry = "\uf4ce";
        public static string Percent = "\uf295";
        public static string Percentage = "\uf541";
        public static string Phone = "\uf095";
        public static string Phone_Slash = "\uf3dd";
        public static string Phone_Square = "\uf098";
        public static string Phone_Volume = "\uf2a0";
        public static string Piggy_Bank = "\uf4d3";
        public static string Pills = "\uf484";
        public static string Place_Of_Worship = "\uf67f";
        public static string Plane = "\uf072";
        public static string Plane_Arrival = "\uf5af";
        public static string Plane_Departure = "\uf5b0";
        public static string Play = "\uf04b";
        public static string Play_Circle = "\uf144";
        public static string Plug = "\uf1e6";
        public static string Plus = "\uf067";
        public static string Plus_Circle = "\uf055";
        public static string Plus_Square = "\uf0fe";
        public static string Podcast = "\uf2ce";
        public static string Poll = "\uf681";
        public static string Poll_H = "\uf682";
        public static string Poo = "\uf2fe";
        public static string Poop = "\uf619";
        public static string Portrait = "\uf3e0";
        public static string Pound_Sign = "\uf154";
        public static string Power_Off = "\uf011";
        public static string Pray = "\uf683";
        public static string Praying_Hands = "\uf684";
        public static string Prescription = "\uf5b1";
        public static string Prescription_Bottle = "\uf485";
        public static string Prescription_Bottle_Alt = "\uf486";
        public static string Print = "\uf02f";
        public static string Procedures = "\uf487";
        public static string Project_Diagram = "\uf542";
        public static string Puzzle_Piece = "\uf12e";
        public static string Qrcode = "\uf029";
        public static string Question = "\uf128";
        public static string Question_Circle = "\uf059";
        public static string Quidditch = "\uf458";
        public static string Quote_Left = "\uf10d";
        public static string Quote_Right = "\uf10e";
        public static string Quran = "\uf687";
        public static string Random = "\uf074";
        public static string Receipt = "\uf543";
        public static string Recycle = "\uf1b8";
        public static string Redo = "\uf01e";
        public static string Redo_Alt = "\uf2f9";
        public static string Registered = "\uf25d";
        public static string Reply = "\uf3e5";
        public static string Reply_All = "\uf122";
        public static string Retweet = "\uf079";
        public static string Ribbon = "\uf4d6";
        public static string Ring = "\uf70b";
        public static string Road = "\uf018";
        public static string Robot = "\uf544";
        public static string Rocket = "\uf135";
        public static string Route = "\uf4d7";
        public static string Rss = "\uf09e";
        public static string Rss_Square = "\uf143";
        public static string Ruble_Sign = "\uf158";
        public static string Ruler = "\uf545";
        public static string Ruler_Combined = "\uf546";
        public static string Ruler_Horizontal = "\uf547";
        public static string Ruler_Vertical = "\uf548";
        public static string Running = "\uf70c";
        public static string Rupee_Sign = "\uf156";
        public static string Sad_Cry = "\uf5b3";
        public static string Sad_Tear = "\uf5b4";
        public static string Save = "\uf0c7";
        public static string School = "\uf549";
        public static string Screwdriver = "\uf54a";
        public static string Scroll = "\uf70e";
        public static string Search = "\uf002";
        public static string Search_Dollar = "\uf688";
        public static string Search_Location = "\uf689";
        public static string Search_Minus = "\uf010";
        public static string Search_Plus = "\uf00e";
        public static string Seedling = "\uf4d8";
        public static string Server = "\uf233";
        public static string Shapes = "\uf61f";
        public static string Share = "\uf064";
        public static string Share_Alt = "\uf1e0";
        public static string Share_Alt_Square = "\uf1e1";
        public static string Share_Square = "\uf14d";
        public static string Shekel_Sign = "\uf20b";
        public static string Shield_Alt = "\uf3ed";
        public static string Ship = "\uf21a";
        public static string Shipping_Fast = "\uf48b";
        public static string Shoe_Prints = "\uf54b";
        public static string Shopping_Bag = "\uf290";
        public static string Shopping_Basket = "\uf291";
        public static string Shopping_Cart = "\uf07a";
        public static string Shower = "\uf2cc";
        public static string Shuttle_Van = "\uf5b6";
        public static string Sign = "\uf4d9";
        public static string Sign_In_Alt = "\uf2f6";
        public static string Sign_Language = "\uf2a7";
        public static string Sign_Out_Alt = "\uf2f5";
        public static string Signal = "\uf012";
        public static string Signature = "\uf5b7";
        public static string Sitemap = "\uf0e8";
        public static string Skull = "\uf54c";
        public static string Skull_Crossbones = "\uf714";
        public static string Slash = "\uf715";
        public static string Sliders_H = "\uf1de";
        public static string Smile = "\uf118";
        public static string Smile_Beam = "\uf5b8";
        public static string Smile_Wink = "\uf4da";
        public static string Smoking = "\uf48d";
        public static string Smoking_Ban = "\uf54d";
        public static string Snowflake = "\uf2dc";
        public static string Socks = "\uf696";
        public static string Solar_Panel = "\uf5ba";
        public static string Sort = "\uf0dc";
        public static string Sort_Alpha_Down = "\uf15d";
        public static string Sort_Alpha_Up = "\uf15e";
        public static string Sort_Amount_Down = "\uf160";
        public static string Sort_Amount_Up = "\uf161";
        public static string Sort_Down = "\uf0dd";
        public static string Sort_Numeric_Down = "\uf162";
        public static string Sort_Numeric_Up = "\uf163";
        public static string Sort_Up = "\uf0de";
        public static string Spa = "\uf5bb";
        public static string Space_Shuttle = "\uf197";
        public static string Spider = "\uf717";
        public static string Spinner = "\uf110";
        public static string Splotch = "\uf5bc";
        public static string Spray_Can = "\uf5bd";
        public static string Square = "\uf0c8";
        public static string Square_Full = "\uf45c";
        public static string Square_Root_Alt = "\uf698";
        public static string Stamp = "\uf5bf";
        public static string Star = "\uf005";
        public static string Star_And_Crescent = "\uf699";
        public static string Star_Half = "\uf089";
        public static string Star_Half_Alt = "\uf5c0";
        public static string Star_Of_David = "\uf69a";
        public static string Star_Of_Life = "\uf621";
        public static string Step_Backward = "\uf048";
        public static string Step_Forward = "\uf051";
        public static string Stethoscope = "\uf0f1";
        public static string Sticky_Note = "\uf249";
        public static string Stop = "\uf04d";
        public static string Stop_Circle = "\uf28d";
        public static string Stopwatch = "\uf2f2";
        public static string Store = "\uf54e";
        public static string Store_Alt = "\uf54f";
        public static string Stream = "\uf550";
        public static string Street_View = "\uf21d";
        public static string Strikethrough = "\uf0cc";
        public static string Stroopwafel = "\uf551";
        public static string Subscript = "\uf12c";
        public static string Subway = "\uf239";
        public static string Suitcase = "\uf0f2";
        public static string Suitcase_Rolling = "\uf5c1";
        public static string Sun = "\uf185";
        public static string Superscript = "\uf12b";
        public static string Surprise = "\uf5c2";
        public static string Swatchbook = "\uf5c3";
        public static string Swimmer = "\uf5c4";
        public static string Swimming_Pool = "\uf5c5";
        public static string Synagogue = "\uf69b";
        public static string Sync = "\uf021";
        public static string Sync_Alt = "\uf2f1";
        public static string Syringe = "\uf48e";
        public static string Table = "\uf0ce";
        public static string Table_Tennis = "\uf45d";
        public static string Tablet = "\uf10a";
        public static string Tablet_Alt = "\uf3fa";
        public static string Tablets = "\uf490";
        public static string Tachometer_Alt = "\uf3fd";
        public static string Tag = "\uf02b";
        public static string Tags = "\uf02c";
        public static string Tape = "\uf4db";
        public static string Tasks = "\uf0ae";
        public static string Taxi = "\uf1ba";
        public static string Teeth = "\uf62e";
        public static string Teeth_Open = "\uf62f";
        public static string Terminal = "\uf120";
        public static string Text_Height = "\uf034";
        public static string Text_Width = "\uf035";
        public static string Th = "\uf00a";
        public static string Th_Large = "\uf009";
        public static string Th_List = "\uf00b";
        public static string Theater_Masks = "\uf630";
        public static string Thermometer = "\uf491";
        public static string Thermometer_Empty = "\uf2cb";
        public static string Thermometer_Full = "\uf2c7";
        public static string Thermometer_Half = "\uf2c9";
        public static string Thermometer_Quarter = "\uf2ca";
        public static string Thermometer_Three_Quarters = "\uf2c8";
        public static string Thumbs_Down = "\uf165";
        public static string Thumbs_Up = "\uf164";
        public static string Thumbtack = "\uf08d";
        public static string Ticket_Alt = "\uf3ff";
        public static string Times = "\uf00d";
        public static string Times_Circle = "\uf057";
        public static string Tint = "\uf043";
        public static string Tint_Slash = "\uf5c7";
        public static string Tired = "\uf5c8";
        public static string Toggle_Off = "\uf204";
        public static string Toggle_On = "\uf205";
        public static string Toilet_Paper = "\uf71e";
        public static string Toolbox = "\uf552";
        public static string Tooth = "\uf5c9";
        public static string Torah = "\uf6a0";
        public static string Torii_Gate = "\uf6a1";
        public static string Tractor = "\uf722";
        public static string Trademark = "\uf25c";
        public static string Traffic_Light = "\uf637";
        public static string Train = "\uf238";
        public static string Transgender = "\uf224";
        public static string Transgender_Alt = "\uf225";
        public static string Trash = "\uf1f8";
        public static string Trash_Alt = "\uf2ed";
        public static string Tree = "\uf1bb";
        public static string Trophy = "\uf091";
        public static string Truck = "\uf0d1";
        public static string Truck_Loading = "\uf4de";
        public static string Truck_Monster = "\uf63b";
        public static string Truck_Moving = "\uf4df";
        public static string Truck_Pickup = "\uf63c";
        public static string Tshirt = "\uf553";
        public static string Tty = "\uf1e4";
        public static string Tv = "\uf26c";
        public static string Umbrella = "\uf0e9";
        public static string Umbrella_Beach = "\uf5ca";
        public static string Underline = "\uf0cd";
        public static string Undo = "\uf0e2";
        public static string Undo_Alt = "\uf2ea";
        public static string Universal_Access = "\uf29a";
        public static string University = "\uf19c";
        public static string Unlink = "\uf127";
        public static string Unlock = "\uf09c";
        public static string Unlock_Alt = "\uf13e";
        public static string Upload = "\uf093";
        public static string User = "\uf007";
        public static string User_Alt = "\uf406";
        public static string User_Alt_Slash = "\uf4fa";
        public static string User_Astronaut = "\uf4fb";
        public static string User_Check = "\uf4fc";
        public static string User_Circle = "\uf2bd";
        public static string User_Clock = "\uf4fd";
        public static string User_Cog = "\uf4fe";
        public static string User_Edit = "\uf4ff";
        public static string User_Friends = "\uf500";
        public static string User_Graduate = "\uf501";
        public static string User_Injured = "\uf728";
        public static string User_Lock = "\uf502";
        public static string User_Md = "\uf0f0";
        public static string User_Minus = "\uf503";
        public static string User_Ninja = "\uf504";
        public static string User_Plus = "\uf234";
        public static string User_Secret = "\uf21b";
        public static string User_Shield = "\uf505";
        public static string User_Slash = "\uf506";
        public static string User_Tag = "\uf507";
        public static string User_Tie = "\uf508";
        public static string User_Times = "\uf235";
        public static string Users = "\uf0c0";
        public static string Users_Cog = "\uf509";
        public static string Utensil_Spoon = "\uf2e5";
        public static string Utensils = "\uf2e7";
        public static string Vector_Square = "\uf5cb";
        public static string Venus = "\uf221";
        public static string Venus_Double = "\uf226";
        public static string Venus_Mars = "\uf228";
        public static string Vial = "\uf492";
        public static string Vials = "\uf493";
        public static string Video = "\uf03d";
        public static string Video_Slash = "\uf4e2";
        public static string Vihara = "\uf6a7";
        public static string Volleyball_Ball = "\uf45f";
        public static string Volume_Down = "\uf027";
        public static string Volume_Mute = "\uf6a9";
        public static string Volume_Off = "\uf026";
        public static string Volume_Up = "\uf028";
        public static string Walking = "\uf554";
        public static string Wallet = "\uf555";
        public static string Warehouse = "\uf494";
        public static string Weight = "\uf496";
        public static string Weight_Hanging = "\uf5cd";
        public static string Wheelchair = "\uf193";
        public static string Wifi = "\uf1eb";
        public static string Wind = "\uf72e";
        public static string Window_Close = "\uf410";
        public static string Window_Maximize = "\uf2d0";
        public static string Window_Minimize = "\uf2d1";
        public static string Window_Restore = "\uf2d2";
        public static string Wine_Bottle = "\uf72f";
        public static string Wine_Glass = "\uf4e3";
        public static string Wine_Glass_Alt = "\uf5ce";
        public static string Won_Sign = "\uf159";
        public static string Wrench = "\uf0ad";
        public static string X_Ray = "\uf497";
        public static string Yen_Sign = "\uf157";
        public static string Yin_Yang = "\uf6ad";
        public static string Address_Book = "\uf2b9";
        public static string Address_Card = "\uf2bb";
        public static string Angry = "\uf556";
        public static string Arrow_Alt_Circle_Down = "\uf358";
        public static string Arrow_Alt_Circle_Left = "\uf359";
        public static string Arrow_Alt_Circle_Right = "\uf35a";
        public static string Arrow_Alt_Circle_Up = "\uf35b";
        public static string Bell = "\uf0f3";
        public static string Bell_Slash = "\uf1f6";
        public static string Bookmark = "\uf02e";
        public static string Building = "\uf1ad";
        public static string Calendar = "\uf133";
        public static string Calendar_Alt = "\uf073";
        public static string Calendar_Check = "\uf274";
        public static string Calendar_Minus = "\uf272";
        public static string Calendar_Plus = "\uf271";
        public static string Calendar_Times = "\uf273";
        public static string Caret_Square_Down = "\uf150";
        public static string Caret_Square_Left = "\uf191";
        public static string Caret_Square_Right = "\uf152";
        public static string Caret_Square_Up = "\uf151";
        public static string Chart_Bar = "\uf080";
        public static string Check_Circle = "\uf058";
        public static string Check_Square = "\uf14a";
        public static string Circle = "\uf111";
        public static string Clipboard = "\uf328";
        public static string Clock = "\uf017";
        public static string Clone = "\uf24d";
        public static string Closed_Captioning = "\uf20a";
        public static string Comment = "\uf075";
        public static string Comment_Alt = "\uf27a";
        public static string Comment_Dots = "\uf4ad";
        public static string Comments = "\uf086";
        public static string Compass = "\uf14e";
        public static string Copy = "\uf0c5";
        public static string Copyright = "\uf1f9";
        public static string Credit_Card = "\uf09d";
        public static string Dizzy = "\uf567";
        public static string Dot_Circle = "\uf192";
        public static string Edit = "\uf044";
        public static string Envelope = "\uf0e0";
        public static string Envelope_Open = "\uf2b6";
        public static string Eye = "\uf06e";
        public static string Eye_Slash = "\uf070";
        public static string File = "\uf15b";
        public static string File_Alt = "\uf15c";
        public static string File_Archive = "\uf1c6";
        public static string File_Audio = "\uf1c7";
        public static string File_Code = "\uf1c9";
        public static string File_Excel = "\uf1c3";
        public static string File_Image = "\uf1c5";
        public static string File_Pdf = "\uf1c1";
        public static string File_Powerpoint = "\uf1c4";
        public static string File_Video = "\uf1c8";
        public static string File_Word = "\uf1c2";
        public static string Flag = "\uf024";
        public static string Flushed = "\uf579";
        public static string Folder = "\uf07b";
        public static string Folder_Open = "\uf07c";
        public static string Font_Awesome_Logo_Full = "\uf4e6";
        public static string Frown = "\uf119";
        public static string Frown_Open = "\uf57a";
        public static string Futbol = "\uf1e3";
        public static string Gem = "\uf3a5";
        public static string Grimace = "\uf57f";
        public static string Grin = "\uf580";
        public static string Grin_Alt = "\uf581";
        public static string Grin_Beam = "\uf582";
        public static string Grin_Beam_Sweat = "\uf583";
        public static string Grin_Hearts = "\uf584";
        public static string Grin_Squint = "\uf585";
        public static string Grin_Squint_Tears = "\uf586";
        public static string Grin_Stars = "\uf587";
        public static string Grin_Tears = "\uf588";
        public static string Grin_Tongue = "\uf589";
        public static string Grin_Tongue_Squint = "\uf58a";
        public static string Grin_Tongue_Wink = "\uf58b";
        public static string Grin_Wink = "\uf58c";
        public static string Hand_Lizard = "\uf258";
        public static string Hand_Paper = "\uf256";
        public static string Hand_Peace = "\uf25b";
        public static string Hand_Point_Down = "\uf0a7";
        public static string Hand_Point_Left = "\uf0a5";
        public static string Hand_Point_Right = "\uf0a4";
        public static string Hand_Point_Up = "\uf0a6";
        public static string Hand_Pointer = "\uf25a";
        public static string Hand_Rock = "\uf255";
        public static string Hand_Scissors = "\uf257";
        public static string Hand_Spock = "\uf259";
        public static string Handshake = "\uf2b5";
        public static string Hdd = "\uf0a0";
        public static string Heart = "\uf004";
        public static string Hospital = "\uf0f8";
        public static string Hourglass = "\uf254";
        public static string Id_Badge = "\uf2c1";
        public static string Id_Card = "\uf2c2";
        public static string Image = "\uf03e";
        public static string Images = "\uf302";
        public static string Keyboard = "\uf11c";
        public static string Kiss = "\uf596";
        public static string Kiss_Beam = "\uf597";
        public static string Kiss_Wink_Heart = "\uf598";
        public static string Laugh = "\uf599";
        public static string Laugh_Beam = "\uf59a";
        public static string Laugh_Squint = "\uf59b";
        public static string Laugh_Wink = "\uf59c";
        public static string Lemon = "\uf094";
        public static string Life_Ring = "\uf1cd";
        public static string Lightbulb = "\uf0eb";
        public static string List_Alt = "\uf022";
        public static string Map = "\uf279";
        public static string Meh = "\uf11a";
        public static string Meh_Blank = "\uf5a4";
        public static string Meh_Rolling_Eyes = "\uf5a5";
        public static string Minus_Square = "\uf146";
        public static string Money_Bill_Alt = "\uf3d1";
        public static string Moon = "\uf186";
        public static string Newspaper = "\uf1ea";
        public static string Object_Group = "\uf247";
        public static string Object_Ungroup = "\uf248";
        public static string Paper_Plane = "\uf1d8";
        public static string Pause_Circle = "\uf28b";
        public static string Play_Circle = "\uf144";
        public static string Plus_Square = "\uf0fe";
        public static string Question_Circle = "\uf059";
        public static string Registered = "\uf25d";
        public static string Sad_Cry = "\uf5b3";
        public static string Sad_Tear = "\uf5b4";
        public static string Save = "\uf0c7";
        public static string Share_Square = "\uf14d";
        public static string Smile = "\uf118";
        public static string Smile_Beam = "\uf5b8";
        public static string Smile_Wink = "\uf4da";
        public static string Snowflake = "\uf2dc";
        public static string Square = "\uf0c8";
        public static string Star = "\uf005";
        public static string Star_Half = "\uf089";
        public static string Sticky_Note = "\uf249";
        public static string Stop_Circle = "\uf28d";
        public static string Sun = "\uf185";
        public static string Surprise = "\uf5c2";
        public static string Thumbs_Down = "\uf165";
        public static string Thumbs_Up = "\uf164";
        public static string Times_Circle = "\uf057";
        public static string Tired = "\uf5c8";
        public static string Trash_Alt = "\uf2ed";
        public static string User = "\uf007";
        public static string User_Circle = "\uf2bd";
        public static string Window_Close = "\uf410";
        public static string Window_Maximize = "\uf2d0";
        public static string Window_Minimize = "\uf2d1";
        public static string Window_Restore = "\uf2d2";
        public static string Unknown60 = "\uf26e";
        public static string Accessible_Icon = "\uf368";
        public static string Accusoft = "\uf369";
        public static string Acquisitions_Incorporated = "\uf6af";
        public static string Adn = "\uf170";
        public static string Adversal = "\uf36a";
        public static string Affiliatetheme = "\uf36b";
        public static string Algolia = "\uf36c";
        public static string Alipay = "\uf642";
        public static string Amazon = "\uf270";
        public static string Amazon_Pay = "\uf42c";
        public static string Amilia = "\uf36d";
        public static string Android = "\uf17b";
        public static string Angellist = "\uf209";
        public static string Angrycreative = "\uf36e";
        public static string Angular = "\uf420";
        public static string App_Store = "\uf36f";
        public static string App_Store_Ios = "\uf370";
        public static string Apper = "\uf371";
        public static string Apple = "\uf179";
        public static string Apple_Pay = "\uf415";
        public static string Asymmetrik = "\uf372";
        public static string Audible = "\uf373";
        public static string Autoprefixer = "\uf41c";
        public static string Avianex = "\uf374";
        public static string Aviato = "\uf421";
        public static string Aws = "\uf375";
        public static string Bandcamp = "\uf2d5";
        public static string Behance = "\uf1b4";
        public static string Behance_Square = "\uf1b5";
        public static string Bimobject = "\uf378";
        public static string Bitbucket = "\uf171";
        public static string Bitcoin = "\uf379";
        public static string Bity = "\uf37a";
        public static string Black_Tie = "\uf27e";
        public static string Blackberry = "\uf37b";
        public static string Blogger = "\uf37c";
        public static string Blogger_B = "\uf37d";
        public static string Bluetooth = "\uf293";
        public static string Bluetooth_B = "\uf294";
        public static string Btc = "\uf15a";
        public static string Buromobelexperte = "\uf37f";
        public static string Buysellads = "\uf20d";
        public static string Cc_Amazon_Pay = "\uf42d";
        public static string Cc_Amex = "\uf1f3";
        public static string Cc_Apple_Pay = "\uf416";
        public static string Cc_Diners_Club = "\uf24c";
        public static string Cc_Discover = "\uf1f2";
        public static string Cc_Jcb = "\uf24b";
        public static string Cc_Mastercard = "\uf1f1";
        public static string Cc_Paypal = "\uf1f4";
        public static string Cc_Stripe = "\uf1f5";
        public static string Cc_Visa = "\uf1f0";
        public static string Centercode = "\uf380";
        public static string Chrome = "\uf268";
        public static string Cloudscale = "\uf383";
        public static string Cloudsmith = "\uf384";
        public static string Cloudversify = "\uf385";
        public static string Codepen = "\uf1cb";
        public static string Codiepie = "\uf284";
        public static string Connectdevelop = "\uf20e";
        public static string Contao = "\uf26d";
        public static string Cpanel = "\uf388";
        public static string Creative_Commons = "\uf25e";
        public static string Creative_Commons_By = "\uf4e7";
        public static string Creative_Commons_Nc = "\uf4e8";
        public static string Creative_Commons_Nc_Eu = "\uf4e9";
        public static string Creative_Commons_Nc_Jp = "\uf4ea";
        public static string Creative_Commons_Nd = "\uf4eb";
        public static string Creative_Commons_Pd = "\uf4ec";
        public static string Creative_Commons_Pd_Alt = "\uf4ed";
        public static string Creative_Commons_Remix = "\uf4ee";
        public static string Creative_Commons_Sa = "\uf4ef";
        public static string Creative_Commons_Sampling = "\uf4f0";
        public static string Creative_Commons_Sampling_Plus = "\uf4f1";
        public static string Creative_Commons_Share = "\uf4f2";
        public static string Creative_Commons_Zero = "\uf4f3";
        public static string Critical_Role = "\uf6c9";
        public static string Css3 = "\uf13c";
        public static string Css3_Alt = "\uf38b";
        public static string Cuttlefish = "\uf38c";
        public static string D_And_D = "\uf38d";
        public static string Dashcube = "\uf210";
        public static string Delicious = "\uf1a5";
        public static string Deploydog = "\uf38e";
        public static string Deskpro = "\uf38f";
        public static string Dev = "\uf6cc";
        public static string Deviantart = "\uf1bd";
        public static string Digg = "\uf1a6";
        public static string Digital_Ocean = "\uf391";
        public static string Discord = "\uf392";
        public static string Discourse = "\uf393";
        public static string Dochub = "\uf394";
        public static string Docker = "\uf395";
        public static string Draft2digital = "\uf396";
        public static string Dribbble = "\uf17d";
        public static string Dribbble_Square = "\uf397";
        public static string Dropbox = "\uf16b";
        public static string Drupal = "\uf1a9";
        public static string Dyalog = "\uf399";
        public static string Earlybirds = "\uf39a";
        public static string Ebay = "\uf4f4";
        public static string Edge = "\uf282";
        public static string Elementor = "\uf430";
        public static string Ello = "\uf5f1";
        public static string Ember = "\uf423";
        public static string Empire = "\uf1d1";
        public static string Envira = "\uf299";
        public static string Erlang = "\uf39d";
        public static string Ethereum = "\uf42e";
        public static string Etsy = "\uf2d7";
        public static string Expeditedssl = "\uf23e";
        public static string Facebook = "\uf09a";
        public static string Facebook_F = "\uf39e";
        public static string Facebook_Messenger = "\uf39f";
        public static string Facebook_Square = "\uf082";
        public static string Fantasy_Flight_Games = "\uf6dc";
        public static string Firefox = "\uf269";
        public static string First_Order = "\uf2b0";
        public static string First_Order_Alt = "\uf50a";
        public static string Firstdraft = "\uf3a1";
        public static string Flickr = "\uf16e";
        public static string Flipboard = "\uf44d";
        public static string Fly = "\uf417";
        public static string Font_Awesome = "\uf2b4";
        public static string Font_Awesome_Alt = "\uf35c";
        public static string Font_Awesome_Flag = "\uf425";
        public static string Font_Awesome_Logo_Full = "\uf4e6";
        public static string Fonticons = "\uf280";
        public static string Fonticons_Fi = "\uf3a2";
        public static string Fort_Awesome = "\uf286";
        public static string Fort_Awesome_Alt = "\uf3a3";
        public static string Forumbee = "\uf211";
        public static string Foursquare = "\uf180";
        public static string Free_Code_Camp = "\uf2c5";
        public static string Freebsd = "\uf3a4";
        public static string Fulcrum = "\uf50b";
        public static string Galactic_Republic = "\uf50c";
        public static string Galactic_Senate = "\uf50d";
        public static string Get_Pocket = "\uf265";
        public static string Gg = "\uf260";
        public static string Gg_Circle = "\uf261";
        public static string Git = "\uf1d3";
        public static string Git_Square = "\uf1d2";
        public static string Github = "\uf09b";
        public static string Github_Alt = "\uf113";
        public static string Github_Square = "\uf092";
        public static string Gitkraken = "\uf3a6";
        public static string Gitlab = "\uf296";
        public static string Gitter = "\uf426";
        public static string Glide = "\uf2a5";
        public static string Glide_G = "\uf2a6";
        public static string Gofore = "\uf3a7";
        public static string Goodreads = "\uf3a8";
        public static string Goodreads_G = "\uf3a9";
        public static string Google = "\uf1a0";
        public static string Google_Drive = "\uf3aa";
        public static string Google_Play = "\uf3ab";
        public static string Google_Plus = "\uf2b3";
        public static string Google_Plus_G = "\uf0d5";
        public static string Google_Plus_Square = "\uf0d4";
        public static string Google_Wallet = "\uf1ee";
        public static string Gratipay = "\uf184";
        public static string Grav = "\uf2d6";
        public static string Gripfire = "\uf3ac";
        public static string Grunt = "\uf3ad";
        public static string Gulp = "\uf3ae";
        public static string Hacker_News = "\uf1d4";
        public static string Hacker_News_Square = "\uf3af";
        public static string Hackerrank = "\uf5f7";
        public static string Hips = "\uf452";
        public static string Hire_A_Helper = "\uf3b0";
        public static string Hooli = "\uf427";
        public static string Hornbill = "\uf592";
        public static string Hotjar = "\uf3b1";
        public static string Houzz = "\uf27c";
        public static string Html5 = "\uf13b";
        public static string Hubspot = "\uf3b2";
        public static string Imdb = "\uf2d8";
        public static string Instagram = "\uf16d";
        public static string Internet_Explorer = "\uf26b";
        public static string Ioxhost = "\uf208";
        public static string Itunes = "\uf3b4";
        public static string Itunes_Note = "\uf3b5";
        public static string Java = "\uf4e4";
        public static string Jedi_Order = "\uf50e";
        public static string Jenkins = "\uf3b6";
        public static string Joget = "\uf3b7";
        public static string Joomla = "\uf1aa";
        public static string Js = "\uf3b8";
        public static string Js_Square = "\uf3b9";
        public static string Jsfiddle = "\uf1cc";
        public static string Kaggle = "\uf5fa";
        public static string Keybase = "\uf4f5";
        public static string Keycdn = "\uf3ba";
        public static string Kickstarter = "\uf3bb";
        public static string Kickstarter_K = "\uf3bc";
        public static string Korvue = "\uf42f";
        public static string Laravel = "\uf3bd";
        public static string Lastfm = "\uf202";
        public static string Lastfm_Square = "\uf203";
        public static string Leanpub = "\uf212";
        public static string Less = "\uf41d";
        public static string Line = "\uf3c0";
        public static string Linkedin = "\uf08c";
        public static string Linkedin_In = "\uf0e1";
        public static string Linode = "\uf2b8";
        public static string Linux = "\uf17c";
        public static string Lyft = "\uf3c3";
        public static string Magento = "\uf3c4";
        public static string Mailchimp = "\uf59e";
        public static string Mandalorian = "\uf50f";
        public static string Markdown = "\uf60f";
        public static string Mastodon = "\uf4f6";
        public static string Maxcdn = "\uf136";
        public static string Medapps = "\uf3c6";
        public static string Medium = "\uf23a";
        public static string Medium_M = "\uf3c7";
        public static string Medrt = "\uf3c8";
        public static string Meetup = "\uf2e0";
        public static string Megaport = "\uf5a3";
        public static string Microsoft = "\uf3ca";
        public static string Mix = "\uf3cb";
        public static string Mixcloud = "\uf289";
        public static string Mizuni = "\uf3cc";
        public static string Modx = "\uf285";
        public static string Monero = "\uf3d0";
        public static string Napster = "\uf3d2";
        public static string Neos = "\uf612";
        public static string Nimblr = "\uf5a8";
        public static string Nintendo_Switch = "\uf418";
        public static string Node = "\uf419";
        public static string Node_Js = "\uf3d3";
        public static string Npm = "\uf3d4";
        public static string Ns8 = "\uf3d5";
        public static string Nutritionix = "\uf3d6";
        public static string Odnoklassniki = "\uf263";
        public static string Odnoklassniki_Square = "\uf264";
        public static string Old_Republic = "\uf510";
        public static string Opencart = "\uf23d";
        public static string Openid = "\uf19b";
        public static string Opera = "\uf26a";
        public static string Optin_Monster = "\uf23c";
        public static string Osi = "\uf41a";
        public static string Page4 = "\uf3d7";
        public static string Pagelines = "\uf18c";
        public static string Palfed = "\uf3d8";
        public static string Patreon = "\uf3d9";
        public static string Paypal = "\uf1ed";
        public static string Penny_Arcade = "\uf704";
        public static string Periscope = "\uf3da";
        public static string Phabricator = "\uf3db";
        public static string Phoenix_Framework = "\uf3dc";
        public static string Phoenix_Squadron = "\uf511";
        public static string Php = "\uf457";
        public static string Pied_Piper = "\uf2ae";
        public static string Pied_Piper_Alt = "\uf1a8";
        public static string Pied_Piper_Hat = "\uf4e5";
        public static string Pied_Piper_Pp = "\uf1a7";
        public static string Pinterest = "\uf0d2";
        public static string Pinterest_P = "\uf231";
        public static string Pinterest_Square = "\uf0d3";
        public static string Playstation = "\uf3df";
        public static string Product_Hunt = "\uf288";
        public static string Pushed = "\uf3e1";
        public static string Python = "\uf3e2";
        public static string Qq = "\uf1d6";
        public static string Quinscape = "\uf459";
        public static string Quora = "\uf2c4";
        public static string R_Project = "\uf4f7";
        public static string Ravelry = "\uf2d9";
        public static string React = "\uf41b";
        public static string Readme = "\uf4d5";
        public static string Rebel = "\uf1d0";
        public static string Red_River = "\uf3e3";
        public static string Reddit = "\uf1a1";
        public static string Reddit_Alien = "\uf281";
        public static string Reddit_Square = "\uf1a2";
        public static string Rendact = "\uf3e4";
        public static string Renren = "\uf18b";
        public static string Replyd = "\uf3e6";
        public static string Researchgate = "\uf4f8";
        public static string Resolving = "\uf3e7";
        public static string Rev = "\uf5b2";
        public static string Rocketchat = "\uf3e8";
        public static string Rockrms = "\uf3e9";
        public static string Safari = "\uf267";
        public static string Sass = "\uf41e";
        public static string Schlix = "\uf3ea";
        public static string Scribd = "\uf28a";
        public static string Searchengin = "\uf3eb";
        public static string Sellcast = "\uf2da";
        public static string Sellsy = "\uf213";
        public static string Servicestack = "\uf3ec";
        public static string Shirtsinbulk = "\uf214";
        public static string Shopware = "\uf5b5";
        public static string Simplybuilt = "\uf215";
        public static string Sistrix = "\uf3ee";
        public static string Sith = "\uf512";
        public static string Skyatlas = "\uf216";
        public static string Skype = "\uf17e";
        public static string Slack = "\uf198";
        public static string Slack_Hash = "\uf3ef";
        public static string Slideshare = "\uf1e7";
        public static string Snapchat = "\uf2ab";
        public static string Snapchat_Ghost = "\uf2ac";
        public static string Snapchat_Square = "\uf2ad";
        public static string Soundcloud = "\uf1be";
        public static string Speakap = "\uf3f3";
        public static string Spotify = "\uf1bc";
        public static string Squarespace = "\uf5be";
        public static string Stack_Exchange = "\uf18d";
        public static string Stack_Overflow = "\uf16c";
        public static string Staylinked = "\uf3f5";
        public static string Steam = "\uf1b6";
        public static string Steam_Square = "\uf1b7";
        public static string Steam_Symbol = "\uf3f6";
        public static string Sticker_Mule = "\uf3f7";
        public static string Strava = "\uf428";
        public static string Stripe = "\uf429";
        public static string Stripe_S = "\uf42a";
        public static string Studiovinari = "\uf3f8";
        public static string Stumbleupon = "\uf1a4";
        public static string Stumbleupon_Circle = "\uf1a3";
        public static string Superpowers = "\uf2dd";
        public static string Supple = "\uf3f9";
        public static string Teamspeak = "\uf4f9";
        public static string Telegram = "\uf2c6";
        public static string Telegram_Plane = "\uf3fe";
        public static string Tencent_Weibo = "\uf1d5";
        public static string The_Red_Yeti = "\uf69d";
        public static string Themeco = "\uf5c6";
        public static string Themeisle = "\uf2b2";
        public static string Trade_Federation = "\uf513";
        public static string Trello = "\uf181";
        public static string Tripadvisor = "\uf262";
        public static string Tumblr = "\uf173";
        public static string Tumblr_Square = "\uf174";
        public static string Twitch = "\uf1e8";
        public static string Twitter = "\uf099";
        public static string Twitter_Square = "\uf081";
        public static string Typo3 = "\uf42b";
        public static string Uber = "\uf402";
        public static string Uikit = "\uf403";
        public static string Uniregistry = "\uf404";
        public static string Untappd = "\uf405";
        public static string Usb = "\uf287";
        public static string Ussunnah = "\uf407";
        public static string Vaadin = "\uf408";
        public static string Viacoin = "\uf237";
        public static string Viadeo = "\uf2a9";
        public static string Viadeo_Square = "\uf2aa";
        public static string Viber = "\uf409";
        public static string Vimeo = "\uf40a";
        public static string Vimeo_Square = "\uf194";
        public static string Vimeo_V = "\uf27d";
        public static string Vine = "\uf1ca";
        public static string Vk = "\uf189";
        public static string Vnv = "\uf40b";
        public static string Vuejs = "\uf41f";
        public static string Weebly = "\uf5cc";
        public static string Weibo = "\uf18a";
        public static string Weixin = "\uf1d7";
        public static string Whatsapp = "\uf232";
        public static string Whatsapp_Square = "\uf40c";
        public static string Whmcs = "\uf40d";
        public static string Wikipedia_W = "\uf266";
        public static string Windows = "\uf17a";
        public static string Wix = "\uf5cf";
        public static string Wizards_Of_The_Coast = "\uf730";
        public static string Wolf_Pack_Battalion = "\uf514";
        public static string Wordpress = "\uf19a";
        public static string Wordpress_Simple = "\uf411";
        public static string Wpbeginner = "\uf297";
        public static string Wpexplorer = "\uf2de";
        public static string Wpforms = "\uf298";
        public static string Xbox = "\uf412";
        public static string Xing = "\uf168";
        public static string Xing_Square = "\uf169";
        public static string Y_Combinator = "\uf23b";
        public static string Yahoo = "\uf19e";
        public static string Yandex = "\uf413";
        public static string Yandex_International = "\uf414";
        public static string Yelp = "\uf1e9";
        public static string Yoast = "\uf2b1";
        public static string Youtube = "\uf167";
        public static string Youtube_Square = "\uf431";
        public static string Zhihu = "\uf63f";
    }



    public static class Brands
    {
        public static string Ad = "\uf641";
        public static string Address_Book = "\uf2b9";
        public static string Address_Card = "\uf2bb";
        public static string Adjust = "\uf042";
        public static string Air_Freshener = "\uf5d0";
        public static string Align_Center = "\uf037";
        public static string Align_Justify = "\uf039";
        public static string Align_Left = "\uf036";
        public static string Align_Right = "\uf038";
        public static string Allergies = "\uf461";
        public static string Ambulance = "\uf0f9";
        public static string American_Sign_Language_Interpreting = "\uf2a3";
        public static string Anchor = "\uf13d";
        public static string Angle_Double_Down = "\uf103";
        public static string Angle_Double_Left = "\uf100";
        public static string Angle_Double_Right = "\uf101";
        public static string Angle_Double_Up = "\uf102";
        public static string Angle_Down = "\uf107";
        public static string Angle_Left = "\uf104";
        public static string Angle_Right = "\uf105";
        public static string Angle_Up = "\uf106";
        public static string Angry = "\uf556";
        public static string Ankh = "\uf644";
        public static string Apple_Alt = "\uf5d1";
        public static string Archive = "\uf187";
        public static string Archway = "\uf557";
        public static string Arrow_Alt_Circle_Down = "\uf358";
        public static string Arrow_Alt_Circle_Left = "\uf359";
        public static string Arrow_Alt_Circle_Right = "\uf35a";
        public static string Arrow_Alt_Circle_Up = "\uf35b";
        public static string Arrow_Circle_Down = "\uf0ab";
        public static string Arrow_Circle_Left = "\uf0a8";
        public static string Arrow_Circle_Right = "\uf0a9";
        public static string Arrow_Circle_Up = "\uf0aa";
        public static string Arrow_Down = "\uf063";
        public static string Arrow_Left = "\uf060";
        public static string Arrow_Right = "\uf061";
        public static string Arrow_Up = "\uf062";
        public static string Arrows_Alt = "\uf0b2";
        public static string Arrows_Alt_H = "\uf337";
        public static string Arrows_Alt_V = "\uf338";
        public static string Assistive_Listening_Systems = "\uf2a2";
        public static string Asterisk = "\uf069";
        public static string At = "\uf1fa";
        public static string Atlas = "\uf558";
        public static string Atom = "\uf5d2";
        public static string Audio_Description = "\uf29e";
        public static string Award = "\uf559";
        public static string Backspace = "\uf55a";
        public static string Backward = "\uf04a";
        public static string Balance_Scale = "\uf24e";
        public static string Ban = "\uf05e";
        public static string Band_Aid = "\uf462";
        public static string Barcode = "\uf02a";
        public static string Bars = "\uf0c9";
        public static string Baseball_Ball = "\uf433";
        public static string Basketball_Ball = "\uf434";
        public static string Bath = "\uf2cd";
        public static string Battery_Empty = "\uf244";
        public static string Battery_Full = "\uf240";
        public static string Battery_Half = "\uf242";
        public static string Battery_Quarter = "\uf243";
        public static string Battery_Three_Quarters = "\uf241";
        public static string Bed = "\uf236";
        public static string Beer = "\uf0fc";
        public static string Bell = "\uf0f3";
        public static string Bell_Slash = "\uf1f6";
        public static string Bezier_Curve = "\uf55b";
        public static string Bible = "\uf647";
        public static string Bicycle = "\uf206";
        public static string Binoculars = "\uf1e5";
        public static string Birthday_Cake = "\uf1fd";
        public static string Blender = "\uf517";
        public static string Blender_Phone = "\uf6b6";
        public static string Blind = "\uf29d";
        public static string Bold = "\uf032";
        public static string Bolt = "\uf0e7";
        public static string Bomb = "\uf1e2";
        public static string Bone = "\uf5d7";
        public static string Bong = "\uf55c";
        public static string Book = "\uf02d";
        public static string Book_Dead = "\uf6b7";
        public static string Book_Open = "\uf518";
        public static string Book_Reader = "\uf5da";
        public static string Bookmark = "\uf02e";
        public static string Bowling_Ball = "\uf436";
        public static string Box = "\uf466";
        public static string Box_Open = "\uf49e";
        public static string Boxes = "\uf468";
        public static string Braille = "\uf2a1";
        public static string Brain = "\uf5dc";
        public static string Briefcase = "\uf0b1";
        public static string Briefcase_Medical = "\uf469";
        public static string Broadcast_Tower = "\uf519";
        public static string Broom = "\uf51a";
        public static string Brush = "\uf55d";
        public static string Bug = "\uf188";
        public static string Building = "\uf1ad";
        public static string Bullhorn = "\uf0a1";
        public static string Bullseye = "\uf140";
        public static string Burn = "\uf46a";
        public static string Bus = "\uf207";
        public static string Bus_Alt = "\uf55e";
        public static string Business_Time = "\uf64a";
        public static string Calculator = "\uf1ec";
        public static string Calendar = "\uf133";
        public static string Calendar_Alt = "\uf073";
        public static string Calendar_Check = "\uf274";
        public static string Calendar_Minus = "\uf272";
        public static string Calendar_Plus = "\uf271";
        public static string Calendar_Times = "\uf273";
        public static string Camera = "\uf030";
        public static string Camera_Retro = "\uf083";
        public static string Campground = "\uf6bb";
        public static string Cannabis = "\uf55f";
        public static string Capsules = "\uf46b";
        public static string Car = "\uf1b9";
        public static string Car_Alt = "\uf5de";
        public static string Car_Battery = "\uf5df";
        public static string Car_Crash = "\uf5e1";
        public static string Car_Side = "\uf5e4";
        public static string Caret_Down = "\uf0d7";
        public static string Caret_Left = "\uf0d9";
        public static string Caret_Right = "\uf0da";
        public static string Caret_Square_Down = "\uf150";
        public static string Caret_Square_Left = "\uf191";
        public static string Caret_Square_Right = "\uf152";
        public static string Caret_Square_Up = "\uf151";
        public static string Caret_Up = "\uf0d8";
        public static string Cart_Arrow_Down = "\uf218";
        public static string Cart_Plus = "\uf217";
        public static string Cat = "\uf6be";
        public static string Certificate = "\uf0a3";
        public static string Chair = "\uf6c0";
        public static string Chalkboard = "\uf51b";
        public static string Chalkboard_Teacher = "\uf51c";
        public static string Charging_Station = "\uf5e7";
        public static string Chart_Area = "\uf1fe";
        public static string Chart_Bar = "\uf080";
        public static string Chart_Line = "\uf201";
        public static string Chart_Pie = "\uf200";
        public static string Check = "\uf00c";
        public static string Check_Circle = "\uf058";
        public static string Check_Double = "\uf560";
        public static string Check_Square = "\uf14a";
        public static string Chess = "\uf439";
        public static string Chess_Bishop = "\uf43a";
        public static string Chess_Board = "\uf43c";
        public static string Chess_King = "\uf43f";
        public static string Chess_Knight = "\uf441";
        public static string Chess_Pawn = "\uf443";
        public static string Chess_Queen = "\uf445";
        public static string Chess_Rook = "\uf447";
        public static string Chevron_Circle_Down = "\uf13a";
        public static string Chevron_Circle_Left = "\uf137";
        public static string Chevron_Circle_Right = "\uf138";
        public static string Chevron_Circle_Up = "\uf139";
        public static string Chevron_Down = "\uf078";
        public static string Chevron_Left = "\uf053";
        public static string Chevron_Right = "\uf054";
        public static string Chevron_Up = "\uf077";
        public static string Child = "\uf1ae";
        public static string Church = "\uf51d";
        public static string Circle = "\uf111";
        public static string Circle_Notch = "\uf1ce";
        public static string City = "\uf64f";
        public static string Clipboard = "\uf328";
        public static string Clipboard_Check = "\uf46c";
        public static string Clipboard_List = "\uf46d";
        public static string Clock = "\uf017";
        public static string Clone = "\uf24d";
        public static string Closed_Captioning = "\uf20a";
        public static string Cloud = "\uf0c2";
        public static string Cloud_Download_Alt = "\uf381";
        public static string Cloud_Moon = "\uf6c3";
        public static string Cloud_Sun = "\uf6c4";
        public static string Cloud_Upload_Alt = "\uf382";
        public static string Cocktail = "\uf561";
        public static string Code = "\uf121";
        public static string Code_Branch = "\uf126";
        public static string Coffee = "\uf0f4";
        public static string Cog = "\uf013";
        public static string Cogs = "\uf085";
        public static string Coins = "\uf51e";
        public static string Columns = "\uf0db";
        public static string Comment = "\uf075";
        public static string Comment_Alt = "\uf27a";
        public static string Comment_Dollar = "\uf651";
        public static string Comment_Dots = "\uf4ad";
        public static string Comment_Slash = "\uf4b3";
        public static string Comments = "\uf086";
        public static string Comments_Dollar = "\uf653";
        public static string Compact_Disc = "\uf51f";
        public static string Compass = "\uf14e";
        public static string Compress = "\uf066";
        public static string Concierge_Bell = "\uf562";
        public static string Cookie = "\uf563";
        public static string Cookie_Bite = "\uf564";
        public static string Copy = "\uf0c5";
        public static string Copyright = "\uf1f9";
        public static string Couch = "\uf4b8";
        public static string Credit_Card = "\uf09d";
        public static string Crop = "\uf125";
        public static string Crop_Alt = "\uf565";
        public static string Cross = "\uf654";
        public static string Crosshairs = "\uf05b";
        public static string Crow = "\uf520";
        public static string Crown = "\uf521";
        public static string Cube = "\uf1b2";
        public static string Cubes = "\uf1b3";
        public static string Cut = "\uf0c4";
        public static string Database = "\uf1c0";
        public static string Deaf = "\uf2a4";
        public static string Desktop = "\uf108";
        public static string Dharmachakra = "\uf655";
        public static string Diagnoses = "\uf470";
        public static string Dice = "\uf522";
        public static string Dice_D20 = "\uf6cf";
        public static string Dice_D6 = "\uf6d1";
        public static string Dice_Five = "\uf523";
        public static string Dice_Four = "\uf524";
        public static string Dice_One = "\uf525";
        public static string Dice_Six = "\uf526";
        public static string Dice_Three = "\uf527";
        public static string Dice_Two = "\uf528";
        public static string Digital_Tachograph = "\uf566";
        public static string Directions = "\uf5eb";
        public static string Divide = "\uf529";
        public static string Dizzy = "\uf567";
        public static string Dna = "\uf471";
        public static string Dog = "\uf6d3";
        public static string Dollar_Sign = "\uf155";
        public static string Dolly = "\uf472";
        public static string Dolly_Flatbed = "\uf474";
        public static string Donate = "\uf4b9";
        public static string Door_Closed = "\uf52a";
        public static string Door_Open = "\uf52b";
        public static string Dot_Circle = "\uf192";
        public static string Dove = "\uf4ba";
        public static string Download = "\uf019";
        public static string Drafting_Compass = "\uf568";
        public static string Dragon = "\uf6d5";
        public static string Draw_Polygon = "\uf5ee";
        public static string Drum = "\uf569";
        public static string Drum_Steelpan = "\uf56a";
        public static string Drumstick_Bite = "\uf6d7";
        public static string Dumbbell = "\uf44b";
        public static string Dungeon = "\uf6d9";
        public static string Edit = "\uf044";
        public static string Eject = "\uf052";
        public static string Ellipsis_H = "\uf141";
        public static string Ellipsis_V = "\uf142";
        public static string Envelope = "\uf0e0";
        public static string Envelope_Open = "\uf2b6";
        public static string Envelope_Open_Text = "\uf658";
        public static string Envelope_Square = "\uf199";
        public static string Equals = "\uf52c";
        public static string Eraser = "\uf12d";
        public static string Euro_Sign = "\uf153";
        public static string Exchange_Alt = "\uf362";
        public static string Exclamation = "\uf12a";
        public static string Exclamation_Circle = "\uf06a";
        public static string Exclamation_Triangle = "\uf071";
        public static string Expand = "\uf065";
        public static string Expand_Arrows_Alt = "\uf31e";
        public static string External_Link_Alt = "\uf35d";
        public static string External_Link_Square_Alt = "\uf360";
        public static string Eye = "\uf06e";
        public static string Eye_Dropper = "\uf1fb";
        public static string Eye_Slash = "\uf070";
        public static string Fast_Backward = "\uf049";
        public static string Fast_Forward = "\uf050";
        public static string Fax = "\uf1ac";
        public static string Feather = "\uf52d";
        public static string Feather_Alt = "\uf56b";
        public static string Female = "\uf182";
        public static string Fighter_Jet = "\uf0fb";
        public static string File = "\uf15b";
        public static string File_Alt = "\uf15c";
        public static string File_Archive = "\uf1c6";
        public static string File_Audio = "\uf1c7";
        public static string File_Code = "\uf1c9";
        public static string File_Contract = "\uf56c";
        public static string File_Csv = "\uf6dd";
        public static string File_Download = "\uf56d";
        public static string File_Excel = "\uf1c3";
        public static string File_Export = "\uf56e";
        public static string File_Image = "\uf1c5";
        public static string File_Import = "\uf56f";
        public static string File_Invoice = "\uf570";
        public static string File_Invoice_Dollar = "\uf571";
        public static string File_Medical = "\uf477";
        public static string File_Medical_Alt = "\uf478";
        public static string File_Pdf = "\uf1c1";
        public static string File_Powerpoint = "\uf1c4";
        public static string File_Prescription = "\uf572";
        public static string File_Signature = "\uf573";
        public static string File_Upload = "\uf574";
        public static string File_Video = "\uf1c8";
        public static string File_Word = "\uf1c2";
        public static string Fill = "\uf575";
        public static string Fill_Drip = "\uf576";
        public static string Film = "\uf008";
        public static string Filter = "\uf0b0";
        public static string Fingerprint = "\uf577";
        public static string Fire = "\uf06d";
        public static string Fire_Extinguisher = "\uf134";
        public static string First_Aid = "\uf479";
        public static string Fish = "\uf578";
        public static string Fist_Raised = "\uf6de";
        public static string Flag = "\uf024";
        public static string Flag_Checkered = "\uf11e";
        public static string Flask = "\uf0c3";
        public static string Flushed = "\uf579";
        public static string Folder = "\uf07b";
        public static string Folder_Minus = "\uf65d";
        public static string Folder_Open = "\uf07c";
        public static string Folder_Plus = "\uf65e";
        public static string Font = "\uf031";
        public static string Font_Awesome_Logo_Full = "\uf4e6";
        public static string Football_Ball = "\uf44e";
        public static string Forward = "\uf04e";
        public static string Frog = "\uf52e";
        public static string Frown = "\uf119";
        public static string Frown_Open = "\uf57a";
        public static string Funnel_Dollar = "\uf662";
        public static string Futbol = "\uf1e3";
        public static string Gamepad = "\uf11b";
        public static string Gas_Pump = "\uf52f";
        public static string Gavel = "\uf0e3";
        public static string Gem = "\uf3a5";
        public static string Genderless = "\uf22d";
        public static string Ghost = "\uf6e2";
        public static string Gift = "\uf06b";
        public static string Glass_Martini = "\uf000";
        public static string Glass_Martini_Alt = "\uf57b";
        public static string Glasses = "\uf530";
        public static string Globe = "\uf0ac";
        public static string Globe_Africa = "\uf57c";
        public static string Globe_Americas = "\uf57d";
        public static string Globe_Asia = "\uf57e";
        public static string Golf_Ball = "\uf450";
        public static string Gopuram = "\uf664";
        public static string Graduation_Cap = "\uf19d";
        public static string Greater_Than = "\uf531";
        public static string Greater_Than_Equal = "\uf532";
        public static string Grimace = "\uf57f";
        public static string Grin = "\uf580";
        public static string Grin_Alt = "\uf581";
        public static string Grin_Beam = "\uf582";
        public static string Grin_Beam_Sweat = "\uf583";
        public static string Grin_Hearts = "\uf584";
        public static string Grin_Squint = "\uf585";
        public static string Grin_Squint_Tears = "\uf586";
        public static string Grin_Stars = "\uf587";
        public static string Grin_Tears = "\uf588";
        public static string Grin_Tongue = "\uf589";
        public static string Grin_Tongue_Squint = "\uf58a";
        public static string Grin_Tongue_Wink = "\uf58b";
        public static string Grin_Wink = "\uf58c";
        public static string Grip_Horizontal = "\uf58d";
        public static string Grip_Vertical = "\uf58e";
        public static string H_Square = "\uf0fd";
        public static string Hammer = "\uf6e3";
        public static string Hamsa = "\uf665";
        public static string Hand_Holding = "\uf4bd";
        public static string Hand_Holding_Heart = "\uf4be";
        public static string Hand_Holding_Usd = "\uf4c0";
        public static string Hand_Lizard = "\uf258";
        public static string Hand_Paper = "\uf256";
        public static string Hand_Peace = "\uf25b";
        public static string Hand_Point_Down = "\uf0a7";
        public static string Hand_Point_Left = "\uf0a5";
        public static string Hand_Point_Right = "\uf0a4";
        public static string Hand_Point_Up = "\uf0a6";
        public static string Hand_Pointer = "\uf25a";
        public static string Hand_Rock = "\uf255";
        public static string Hand_Scissors = "\uf257";
        public static string Hand_Spock = "\uf259";
        public static string Hands = "\uf4c2";
        public static string Hands_Helping = "\uf4c4";
        public static string Handshake = "\uf2b5";
        public static string Hanukiah = "\uf6e6";
        public static string Hashtag = "\uf292";
        public static string Hat_Wizard = "\uf6e8";
        public static string Haykal = "\uf666";
        public static string Hdd = "\uf0a0";
        public static string Heading = "\uf1dc";
        public static string Headphones = "\uf025";
        public static string Headphones_Alt = "\uf58f";
        public static string Headset = "\uf590";
        public static string Heart = "\uf004";
        public static string Heartbeat = "\uf21e";
        public static string Helicopter = "\uf533";
        public static string Highlighter = "\uf591";
        public static string Hiking = "\uf6ec";
        public static string Hippo = "\uf6ed";
        public static string History = "\uf1da";
        public static string Hockey_Puck = "\uf453";
        public static string Home = "\uf015";
        public static string Horse = "\uf6f0";
        public static string Hospital = "\uf0f8";
        public static string Hospital_Alt = "\uf47d";
        public static string Hospital_Symbol = "\uf47e";
        public static string Hot_Tub = "\uf593";
        public static string Hotel = "\uf594";
        public static string Hourglass = "\uf254";
        public static string Hourglass_End = "\uf253";
        public static string Hourglass_Half = "\uf252";
        public static string Hourglass_Start = "\uf251";
        public static string House_Damage = "\uf6f1";
        public static string Hryvnia = "\uf6f2";
        public static string I_Cursor = "\uf246";
        public static string Id_Badge = "\uf2c1";
        public static string Id_Card = "\uf2c2";
        public static string Id_Card_Alt = "\uf47f";
        public static string Image = "\uf03e";
        public static string Images = "\uf302";
        public static string Inbox = "\uf01c";
        public static string Indent = "\uf03c";
        public static string Industry = "\uf275";
        public static string Infinity = "\uf534";
        public static string Info = "\uf129";
        public static string Info_Circle = "\uf05a";
        public static string Italic = "\uf033";
        public static string Jedi = "\uf669";
        public static string Joint = "\uf595";
        public static string Journal_Whills = "\uf66a";
        public static string Kaaba = "\uf66b";
        public static string Key = "\uf084";
        public static string Keyboard = "\uf11c";
        public static string Khanda = "\uf66d";
        public static string Kiss = "\uf596";
        public static string Kiss_Beam = "\uf597";
        public static string Kiss_Wink_Heart = "\uf598";
        public static string Kiwi_Bird = "\uf535";
        public static string Landmark = "\uf66f";
        public static string Language = "\uf1ab";
        public static string Laptop = "\uf109";
        public static string Laptop_Code = "\uf5fc";
        public static string Laugh = "\uf599";
        public static string Laugh_Beam = "\uf59a";
        public static string Laugh_Squint = "\uf59b";
        public static string Laugh_Wink = "\uf59c";
        public static string Layer_Group = "\uf5fd";
        public static string Leaf = "\uf06c";
        public static string Lemon = "\uf094";
        public static string Less_Than = "\uf536";
        public static string Less_Than_Equal = "\uf537";
        public static string Level_Down_Alt = "\uf3be";
        public static string Level_Up_Alt = "\uf3bf";
        public static string Life_Ring = "\uf1cd";
        public static string Lightbulb = "\uf0eb";
        public static string Link = "\uf0c1";
        public static string Lira_Sign = "\uf195";
        public static string List = "\uf03a";
        public static string List_Alt = "\uf022";
        public static string List_Ol = "\uf0cb";
        public static string List_Ul = "\uf0ca";
        public static string Location_Arrow = "\uf124";
        public static string Lock = "\uf023";
        public static string Lock_Open = "\uf3c1";
        public static string Long_Arrow_Alt_Down = "\uf309";
        public static string Long_Arrow_Alt_Left = "\uf30a";
        public static string Long_Arrow_Alt_Right = "\uf30b";
        public static string Long_Arrow_Alt_Up = "\uf30c";
        public static string Low_Vision = "\uf2a8";
        public static string Luggage_Cart = "\uf59d";
        public static string Magic = "\uf0d0";
        public static string Magnet = "\uf076";
        public static string Mail_Bulk = "\uf674";
        public static string Male = "\uf183";
        public static string Map = "\uf279";
        public static string Map_Marked = "\uf59f";
        public static string Map_Marked_Alt = "\uf5a0";
        public static string Map_Marker = "\uf041";
        public static string Map_Marker_Alt = "\uf3c5";
        public static string Map_Pin = "\uf276";
        public static string Map_Signs = "\uf277";
        public static string Marker = "\uf5a1";
        public static string Mars = "\uf222";
        public static string Mars_Double = "\uf227";
        public static string Mars_Stroke = "\uf229";
        public static string Mars_Stroke_H = "\uf22b";
        public static string Mars_Stroke_V = "\uf22a";
        public static string Mask = "\uf6fa";
        public static string Medal = "\uf5a2";
        public static string Medkit = "\uf0fa";
        public static string Meh = "\uf11a";
        public static string Meh_Blank = "\uf5a4";
        public static string Meh_Rolling_Eyes = "\uf5a5";
        public static string Memory = "\uf538";
        public static string Menorah = "\uf676";
        public static string Mercury = "\uf223";
        public static string Microchip = "\uf2db";
        public static string Microphone = "\uf130";
        public static string Microphone_Alt = "\uf3c9";
        public static string Microphone_Alt_Slash = "\uf539";
        public static string Microphone_Slash = "\uf131";
        public static string Microscope = "\uf610";
        public static string Minus = "\uf068";
        public static string Minus_Circle = "\uf056";
        public static string Minus_Square = "\uf146";
        public static string Mobile = "\uf10b";
        public static string Mobile_Alt = "\uf3cd";
        public static string Money_Bill = "\uf0d6";
        public static string Money_Bill_Alt = "\uf3d1";
        public static string Money_Bill_Wave = "\uf53a";
        public static string Money_Bill_Wave_Alt = "\uf53b";
        public static string Money_Check = "\uf53c";
        public static string Money_Check_Alt = "\uf53d";
        public static string Monument = "\uf5a6";
        public static string Moon = "\uf186";
        public static string Mortar_Pestle = "\uf5a7";
        public static string Mosque = "\uf678";
        public static string Motorcycle = "\uf21c";
        public static string Mountain = "\uf6fc";
        public static string Mouse_Pointer = "\uf245";
        public static string Music = "\uf001";
        public static string Network_Wired = "\uf6ff";
        public static string Neuter = "\uf22c";
        public static string Newspaper = "\uf1ea";
        public static string Not_Equal = "\uf53e";
        public static string Notes_Medical = "\uf481";
        public static string Object_Group = "\uf247";
        public static string Object_Ungroup = "\uf248";
        public static string Oil_Can = "\uf613";
        public static string Om = "\uf679";
        public static string Otter = "\uf700";
        public static string Outdent = "\uf03b";
        public static string Paint_Brush = "\uf1fc";
        public static string Paint_Roller = "\uf5aa";
        public static string Palette = "\uf53f";
        public static string Pallet = "\uf482";
        public static string Paper_Plane = "\uf1d8";
        public static string Paperclip = "\uf0c6";
        public static string Parachute_Box = "\uf4cd";
        public static string Paragraph = "\uf1dd";
        public static string Parking = "\uf540";
        public static string Passport = "\uf5ab";
        public static string Pastafarianism = "\uf67b";
        public static string Paste = "\uf0ea";
        public static string Pause = "\uf04c";
        public static string Pause_Circle = "\uf28b";
        public static string Paw = "\uf1b0";
        public static string Peace = "\uf67c";
        public static string Pen = "\uf304";
        public static string Pen_Alt = "\uf305";
        public static string Pen_Fancy = "\uf5ac";
        public static string Pen_Nib = "\uf5ad";
        public static string Pen_Square = "\uf14b";
        public static string Pencil_Alt = "\uf303";
        public static string Pencil_Ruler = "\uf5ae";
        public static string People_Carry = "\uf4ce";
        public static string Percent = "\uf295";
        public static string Percentage = "\uf541";
        public static string Phone = "\uf095";
        public static string Phone_Slash = "\uf3dd";
        public static string Phone_Square = "\uf098";
        public static string Phone_Volume = "\uf2a0";
        public static string Piggy_Bank = "\uf4d3";
        public static string Pills = "\uf484";
        public static string Place_Of_Worship = "\uf67f";
        public static string Plane = "\uf072";
        public static string Plane_Arrival = "\uf5af";
        public static string Plane_Departure = "\uf5b0";
        public static string Play = "\uf04b";
        public static string Play_Circle = "\uf144";
        public static string Plug = "\uf1e6";
        public static string Plus = "\uf067";
        public static string Plus_Circle = "\uf055";
        public static string Plus_Square = "\uf0fe";
        public static string Podcast = "\uf2ce";
        public static string Poll = "\uf681";
        public static string Poll_H = "\uf682";
        public static string Poo = "\uf2fe";
        public static string Poop = "\uf619";
        public static string Portrait = "\uf3e0";
        public static string Pound_Sign = "\uf154";
        public static string Power_Off = "\uf011";
        public static string Pray = "\uf683";
        public static string Praying_Hands = "\uf684";
        public static string Prescription = "\uf5b1";
        public static string Prescription_Bottle = "\uf485";
        public static string Prescription_Bottle_Alt = "\uf486";
        public static string Print = "\uf02f";
        public static string Procedures = "\uf487";
        public static string Project_Diagram = "\uf542";
        public static string Puzzle_Piece = "\uf12e";
        public static string Qrcode = "\uf029";
        public static string Question = "\uf128";
        public static string Question_Circle = "\uf059";
        public static string Quidditch = "\uf458";
        public static string Quote_Left = "\uf10d";
        public static string Quote_Right = "\uf10e";
        public static string Quran = "\uf687";
        public static string Random = "\uf074";
        public static string Receipt = "\uf543";
        public static string Recycle = "\uf1b8";
        public static string Redo = "\uf01e";
        public static string Redo_Alt = "\uf2f9";
        public static string Registered = "\uf25d";
        public static string Reply = "\uf3e5";
        public static string Reply_All = "\uf122";
        public static string Retweet = "\uf079";
        public static string Ribbon = "\uf4d6";
        public static string Ring = "\uf70b";
        public static string Road = "\uf018";
        public static string Robot = "\uf544";
        public static string Rocket = "\uf135";
        public static string Route = "\uf4d7";
        public static string Rss = "\uf09e";
        public static string Rss_Square = "\uf143";
        public static string Ruble_Sign = "\uf158";
        public static string Ruler = "\uf545";
        public static string Ruler_Combined = "\uf546";
        public static string Ruler_Horizontal = "\uf547";
        public static string Ruler_Vertical = "\uf548";
        public static string Running = "\uf70c";
        public static string Rupee_Sign = "\uf156";
        public static string Sad_Cry = "\uf5b3";
        public static string Sad_Tear = "\uf5b4";
        public static string Save = "\uf0c7";
        public static string School = "\uf549";
        public static string Screwdriver = "\uf54a";
        public static string Scroll = "\uf70e";
        public static string Search = "\uf002";
        public static string Search_Dollar = "\uf688";
        public static string Search_Location = "\uf689";
        public static string Search_Minus = "\uf010";
        public static string Search_Plus = "\uf00e";
        public static string Seedling = "\uf4d8";
        public static string Server = "\uf233";
        public static string Shapes = "\uf61f";
        public static string Share = "\uf064";
        public static string Share_Alt = "\uf1e0";
        public static string Share_Alt_Square = "\uf1e1";
        public static string Share_Square = "\uf14d";
        public static string Shekel_Sign = "\uf20b";
        public static string Shield_Alt = "\uf3ed";
        public static string Ship = "\uf21a";
        public static string Shipping_Fast = "\uf48b";
        public static string Shoe_Prints = "\uf54b";
        public static string Shopping_Bag = "\uf290";
        public static string Shopping_Basket = "\uf291";
        public static string Shopping_Cart = "\uf07a";
        public static string Shower = "\uf2cc";
        public static string Shuttle_Van = "\uf5b6";
        public static string Sign = "\uf4d9";
        public static string Sign_In_Alt = "\uf2f6";
        public static string Sign_Language = "\uf2a7";
        public static string Sign_Out_Alt = "\uf2f5";
        public static string Signal = "\uf012";
        public static string Signature = "\uf5b7";
        public static string Sitemap = "\uf0e8";
        public static string Skull = "\uf54c";
        public static string Skull_Crossbones = "\uf714";
        public static string Slash = "\uf715";
        public static string Sliders_H = "\uf1de";
        public static string Smile = "\uf118";
        public static string Smile_Beam = "\uf5b8";
        public static string Smile_Wink = "\uf4da";
        public static string Smoking = "\uf48d";
        public static string Smoking_Ban = "\uf54d";
        public static string Snowflake = "\uf2dc";
        public static string Socks = "\uf696";
        public static string Solar_Panel = "\uf5ba";
        public static string Sort = "\uf0dc";
        public static string Sort_Alpha_Down = "\uf15d";
        public static string Sort_Alpha_Up = "\uf15e";
        public static string Sort_Amount_Down = "\uf160";
        public static string Sort_Amount_Up = "\uf161";
        public static string Sort_Down = "\uf0dd";
        public static string Sort_Numeric_Down = "\uf162";
        public static string Sort_Numeric_Up = "\uf163";
        public static string Sort_Up = "\uf0de";
        public static string Spa = "\uf5bb";
        public static string Space_Shuttle = "\uf197";
        public static string Spider = "\uf717";
        public static string Spinner = "\uf110";
        public static string Splotch = "\uf5bc";
        public static string Spray_Can = "\uf5bd";
        public static string Square = "\uf0c8";
        public static string Square_Full = "\uf45c";
        public static string Square_Root_Alt = "\uf698";
        public static string Stamp = "\uf5bf";
        public static string Star = "\uf005";
        public static string Star_And_Crescent = "\uf699";
        public static string Star_Half = "\uf089";
        public static string Star_Half_Alt = "\uf5c0";
        public static string Star_Of_David = "\uf69a";
        public static string Star_Of_Life = "\uf621";
        public static string Step_Backward = "\uf048";
        public static string Step_Forward = "\uf051";
        public static string Stethoscope = "\uf0f1";
        public static string Sticky_Note = "\uf249";
        public static string Stop = "\uf04d";
        public static string Stop_Circle = "\uf28d";
        public static string Stopwatch = "\uf2f2";
        public static string Store = "\uf54e";
        public static string Store_Alt = "\uf54f";
        public static string Stream = "\uf550";
        public static string Street_View = "\uf21d";
        public static string Strikethrough = "\uf0cc";
        public static string Stroopwafel = "\uf551";
        public static string Subscript = "\uf12c";
        public static string Subway = "\uf239";
        public static string Suitcase = "\uf0f2";
        public static string Suitcase_Rolling = "\uf5c1";
        public static string Sun = "\uf185";
        public static string Superscript = "\uf12b";
        public static string Surprise = "\uf5c2";
        public static string Swatchbook = "\uf5c3";
        public static string Swimmer = "\uf5c4";
        public static string Swimming_Pool = "\uf5c5";
        public static string Synagogue = "\uf69b";
        public static string Sync = "\uf021";
        public static string Sync_Alt = "\uf2f1";
        public static string Syringe = "\uf48e";
        public static string Table = "\uf0ce";
        public static string Table_Tennis = "\uf45d";
        public static string Tablet = "\uf10a";
        public static string Tablet_Alt = "\uf3fa";
        public static string Tablets = "\uf490";
        public static string Tachometer_Alt = "\uf3fd";
        public static string Tag = "\uf02b";
        public static string Tags = "\uf02c";
        public static string Tape = "\uf4db";
        public static string Tasks = "\uf0ae";
        public static string Taxi = "\uf1ba";
        public static string Teeth = "\uf62e";
        public static string Teeth_Open = "\uf62f";
        public static string Terminal = "\uf120";
        public static string Text_Height = "\uf034";
        public static string Text_Width = "\uf035";
        public static string Th = "\uf00a";
        public static string Th_Large = "\uf009";
        public static string Th_List = "\uf00b";
        public static string Theater_Masks = "\uf630";
        public static string Thermometer = "\uf491";
        public static string Thermometer_Empty = "\uf2cb";
        public static string Thermometer_Full = "\uf2c7";
        public static string Thermometer_Half = "\uf2c9";
        public static string Thermometer_Quarter = "\uf2ca";
        public static string Thermometer_Three_Quarters = "\uf2c8";
        public static string Thumbs_Down = "\uf165";
        public static string Thumbs_Up = "\uf164";
        public static string Thumbtack = "\uf08d";
        public static string Ticket_Alt = "\uf3ff";
        public static string Times = "\uf00d";
        public static string Times_Circle = "\uf057";
        public static string Tint = "\uf043";
        public static string Tint_Slash = "\uf5c7";
        public static string Tired = "\uf5c8";
        public static string Toggle_Off = "\uf204";
        public static string Toggle_On = "\uf205";
        public static string Toilet_Paper = "\uf71e";
        public static string Toolbox = "\uf552";
        public static string Tooth = "\uf5c9";
        public static string Torah = "\uf6a0";
        public static string Torii_Gate = "\uf6a1";
        public static string Tractor = "\uf722";
        public static string Trademark = "\uf25c";
        public static string Traffic_Light = "\uf637";
        public static string Train = "\uf238";
        public static string Transgender = "\uf224";
        public static string Transgender_Alt = "\uf225";
        public static string Trash = "\uf1f8";
        public static string Trash_Alt = "\uf2ed";
        public static string Tree = "\uf1bb";
        public static string Trophy = "\uf091";
        public static string Truck = "\uf0d1";
        public static string Truck_Loading = "\uf4de";
        public static string Truck_Monster = "\uf63b";
        public static string Truck_Moving = "\uf4df";
        public static string Truck_Pickup = "\uf63c";
        public static string Tshirt = "\uf553";
        public static string Tty = "\uf1e4";
        public static string Tv = "\uf26c";
        public static string Umbrella = "\uf0e9";
        public static string Umbrella_Beach = "\uf5ca";
        public static string Underline = "\uf0cd";
        public static string Undo = "\uf0e2";
        public static string Undo_Alt = "\uf2ea";
        public static string Universal_Access = "\uf29a";
        public static string University = "\uf19c";
        public static string Unlink = "\uf127";
        public static string Unlock = "\uf09c";
        public static string Unlock_Alt = "\uf13e";
        public static string Upload = "\uf093";
        public static string User = "\uf007";
        public static string User_Alt = "\uf406";
        public static string User_Alt_Slash = "\uf4fa";
        public static string User_Astronaut = "\uf4fb";
        public static string User_Check = "\uf4fc";
        public static string User_Circle = "\uf2bd";
        public static string User_Clock = "\uf4fd";
        public static string User_Cog = "\uf4fe";
        public static string User_Edit = "\uf4ff";
        public static string User_Friends = "\uf500";
        public static string User_Graduate = "\uf501";
        public static string User_Injured = "\uf728";
        public static string User_Lock = "\uf502";
        public static string User_Md = "\uf0f0";
        public static string User_Minus = "\uf503";
        public static string User_Ninja = "\uf504";
        public static string User_Plus = "\uf234";
        public static string User_Secret = "\uf21b";
        public static string User_Shield = "\uf505";
        public static string User_Slash = "\uf506";
        public static string User_Tag = "\uf507";
        public static string User_Tie = "\uf508";
        public static string User_Times = "\uf235";
        public static string Users = "\uf0c0";
        public static string Users_Cog = "\uf509";
        public static string Utensil_Spoon = "\uf2e5";
        public static string Utensils = "\uf2e7";
        public static string Vector_Square = "\uf5cb";
        public static string Venus = "\uf221";
        public static string Venus_Double = "\uf226";
        public static string Venus_Mars = "\uf228";
        public static string Vial = "\uf492";
        public static string Vials = "\uf493";
        public static string Video = "\uf03d";
        public static string Video_Slash = "\uf4e2";
        public static string Vihara = "\uf6a7";
        public static string Volleyball_Ball = "\uf45f";
        public static string Volume_Down = "\uf027";
        public static string Volume_Mute = "\uf6a9";
        public static string Volume_Off = "\uf026";
        public static string Volume_Up = "\uf028";
        public static string Walking = "\uf554";
        public static string Wallet = "\uf555";
        public static string Warehouse = "\uf494";
        public static string Weight = "\uf496";
        public static string Weight_Hanging = "\uf5cd";
        public static string Wheelchair = "\uf193";
        public static string Wifi = "\uf1eb";
        public static string Wind = "\uf72e";
        public static string Window_Close = "\uf410";
        public static string Window_Maximize = "\uf2d0";
        public static string Window_Minimize = "\uf2d1";
        public static string Window_Restore = "\uf2d2";
        public static string Wine_Bottle = "\uf72f";
        public static string Wine_Glass = "\uf4e3";
        public static string Wine_Glass_Alt = "\uf5ce";
        public static string Won_Sign = "\uf159";
        public static string Wrench = "\uf0ad";
        public static string X_Ray = "\uf497";
        public static string Yen_Sign = "\uf157";
        public static string Yin_Yang = "\uf6ad";
        public static string Address_Book = "\uf2b9";
        public static string Address_Card = "\uf2bb";
        public static string Angry = "\uf556";
        public static string Arrow_Alt_Circle_Down = "\uf358";
        public static string Arrow_Alt_Circle_Left = "\uf359";
        public static string Arrow_Alt_Circle_Right = "\uf35a";
        public static string Arrow_Alt_Circle_Up = "\uf35b";
        public static string Bell = "\uf0f3";
        public static string Bell_Slash = "\uf1f6";
        public static string Bookmark = "\uf02e";
        public static string Building = "\uf1ad";
        public static string Calendar = "\uf133";
        public static string Calendar_Alt = "\uf073";
        public static string Calendar_Check = "\uf274";
        public static string Calendar_Minus = "\uf272";
        public static string Calendar_Plus = "\uf271";
        public static string Calendar_Times = "\uf273";
        public static string Caret_Square_Down = "\uf150";
        public static string Caret_Square_Left = "\uf191";
        public static string Caret_Square_Right = "\uf152";
        public static string Caret_Square_Up = "\uf151";
        public static string Chart_Bar = "\uf080";
        public static string Check_Circle = "\uf058";
        public static string Check_Square = "\uf14a";
        public static string Circle = "\uf111";
        public static string Clipboard = "\uf328";
        public static string Clock = "\uf017";
        public static string Clone = "\uf24d";
        public static string Closed_Captioning = "\uf20a";
        public static string Comment = "\uf075";
        public static string Comment_Alt = "\uf27a";
        public static string Comment_Dots = "\uf4ad";
        public static string Comments = "\uf086";
        public static string Compass = "\uf14e";
        public static string Copy = "\uf0c5";
        public static string Copyright = "\uf1f9";
        public static string Credit_Card = "\uf09d";
        public static string Dizzy = "\uf567";
        public static string Dot_Circle = "\uf192";
        public static string Edit = "\uf044";
        public static string Envelope = "\uf0e0";
        public static string Envelope_Open = "\uf2b6";
        public static string Eye = "\uf06e";
        public static string Eye_Slash = "\uf070";
        public static string File = "\uf15b";
        public static string File_Alt = "\uf15c";
        public static string File_Archive = "\uf1c6";
        public static string File_Audio = "\uf1c7";
        public static string File_Code = "\uf1c9";
        public static string File_Excel = "\uf1c3";
        public static string File_Image = "\uf1c5";
        public static string File_Pdf = "\uf1c1";
        public static string File_Powerpoint = "\uf1c4";
        public static string File_Video = "\uf1c8";
        public static string File_Word = "\uf1c2";
        public static string Flag = "\uf024";
        public static string Flushed = "\uf579";
        public static string Folder = "\uf07b";
        public static string Folder_Open = "\uf07c";
        public static string Font_Awesome_Logo_Full = "\uf4e6";
        public static string Frown = "\uf119";
        public static string Frown_Open = "\uf57a";
        public static string Futbol = "\uf1e3";
        public static string Gem = "\uf3a5";
        public static string Grimace = "\uf57f";
        public static string Grin = "\uf580";
        public static string Grin_Alt = "\uf581";
        public static string Grin_Beam = "\uf582";
        public static string Grin_Beam_Sweat = "\uf583";
        public static string Grin_Hearts = "\uf584";
        public static string Grin_Squint = "\uf585";
        public static string Grin_Squint_Tears = "\uf586";
        public static string Grin_Stars = "\uf587";
        public static string Grin_Tears = "\uf588";
        public static string Grin_Tongue = "\uf589";
        public static string Grin_Tongue_Squint = "\uf58a";
        public static string Grin_Tongue_Wink = "\uf58b";
        public static string Grin_Wink = "\uf58c";
        public static string Hand_Lizard = "\uf258";
        public static string Hand_Paper = "\uf256";
        public static string Hand_Peace = "\uf25b";
        public static string Hand_Point_Down = "\uf0a7";
        public static string Hand_Point_Left = "\uf0a5";
        public static string Hand_Point_Right = "\uf0a4";
        public static string Hand_Point_Up = "\uf0a6";
        public static string Hand_Pointer = "\uf25a";
        public static string Hand_Rock = "\uf255";
        public static string Hand_Scissors = "\uf257";
        public static string Hand_Spock = "\uf259";
        public static string Handshake = "\uf2b5";
        public static string Hdd = "\uf0a0";
        public static string Heart = "\uf004";
        public static string Hospital = "\uf0f8";
        public static string Hourglass = "\uf254";
        public static string Id_Badge = "\uf2c1";
        public static string Id_Card = "\uf2c2";
        public static string Image = "\uf03e";
        public static string Images = "\uf302";
        public static string Keyboard = "\uf11c";
        public static string Kiss = "\uf596";
        public static string Kiss_Beam = "\uf597";
        public static string Kiss_Wink_Heart = "\uf598";
        public static string Laugh = "\uf599";
        public static string Laugh_Beam = "\uf59a";
        public static string Laugh_Squint = "\uf59b";
        public static string Laugh_Wink = "\uf59c";
        public static string Lemon = "\uf094";
        public static string Life_Ring = "\uf1cd";
        public static string Lightbulb = "\uf0eb";
        public static string List_Alt = "\uf022";
        public static string Map = "\uf279";
        public static string Meh = "\uf11a";
        public static string Meh_Blank = "\uf5a4";
        public static string Meh_Rolling_Eyes = "\uf5a5";
        public static string Minus_Square = "\uf146";
        public static string Money_Bill_Alt = "\uf3d1";
        public static string Moon = "\uf186";
        public static string Newspaper = "\uf1ea";
        public static string Object_Group = "\uf247";
        public static string Object_Ungroup = "\uf248";
        public static string Paper_Plane = "\uf1d8";
        public static string Pause_Circle = "\uf28b";
        public static string Play_Circle = "\uf144";
        public static string Plus_Square = "\uf0fe";
        public static string Question_Circle = "\uf059";
        public static string Registered = "\uf25d";
        public static string Sad_Cry = "\uf5b3";
        public static string Sad_Tear = "\uf5b4";
        public static string Save = "\uf0c7";
        public static string Share_Square = "\uf14d";
        public static string Smile = "\uf118";
        public static string Smile_Beam = "\uf5b8";
        public static string Smile_Wink = "\uf4da";
        public static string Snowflake = "\uf2dc";
        public static string Square = "\uf0c8";
        public static string Star = "\uf005";
        public static string Star_Half = "\uf089";
        public static string Sticky_Note = "\uf249";
        public static string Stop_Circle = "\uf28d";
        public static string Sun = "\uf185";
        public static string Surprise = "\uf5c2";
        public static string Thumbs_Down = "\uf165";
        public static string Thumbs_Up = "\uf164";
        public static string Times_Circle = "\uf057";
        public static string Tired = "\uf5c8";
        public static string Trash_Alt = "\uf2ed";
        public static string User = "\uf007";
        public static string User_Circle = "\uf2bd";
        public static string Window_Close = "\uf410";
        public static string Window_Maximize = "\uf2d0";
        public static string Window_Minimize = "\uf2d1";
        public static string Window_Restore = "\uf2d2";
        public static string Unknown75 = "\uf26e";
        public static string Accessible_Icon = "\uf368";
        public static string Accusoft = "\uf369";
        public static string Acquisitions_Incorporated = "\uf6af";
        public static string Adn = "\uf170";
        public static string Adversal = "\uf36a";
        public static string Affiliatetheme = "\uf36b";
        public static string Algolia = "\uf36c";
        public static string Alipay = "\uf642";
        public static string Amazon = "\uf270";
        public static string Amazon_Pay = "\uf42c";
        public static string Amilia = "\uf36d";
        public static string Android = "\uf17b";
        public static string Angellist = "\uf209";
        public static string Angrycreative = "\uf36e";
        public static string Angular = "\uf420";
        public static string App_Store = "\uf36f";
        public static string App_Store_Ios = "\uf370";
        public static string Apper = "\uf371";
        public static string Apple = "\uf179";
        public static string Apple_Pay = "\uf415";
        public static string Asymmetrik = "\uf372";
        public static string Audible = "\uf373";
        public static string Autoprefixer = "\uf41c";
        public static string Avianex = "\uf374";
        public static string Aviato = "\uf421";
        public static string Aws = "\uf375";
        public static string Bandcamp = "\uf2d5";
        public static string Behance = "\uf1b4";
        public static string Behance_Square = "\uf1b5";
        public static string Bimobject = "\uf378";
        public static string Bitbucket = "\uf171";
        public static string Bitcoin = "\uf379";
        public static string Bity = "\uf37a";
        public static string Black_Tie = "\uf27e";
        public static string Blackberry = "\uf37b";
        public static string Blogger = "\uf37c";
        public static string Blogger_B = "\uf37d";
        public static string Bluetooth = "\uf293";
        public static string Bluetooth_B = "\uf294";
        public static string Btc = "\uf15a";
        public static string Buromobelexperte = "\uf37f";
        public static string Buysellads = "\uf20d";
        public static string Cc_Amazon_Pay = "\uf42d";
        public static string Cc_Amex = "\uf1f3";
        public static string Cc_Apple_Pay = "\uf416";
        public static string Cc_Diners_Club = "\uf24c";
        public static string Cc_Discover = "\uf1f2";
        public static string Cc_Jcb = "\uf24b";
        public static string Cc_Mastercard = "\uf1f1";
        public static string Cc_Paypal = "\uf1f4";
        public static string Cc_Stripe = "\uf1f5";
        public static string Cc_Visa = "\uf1f0";
        public static string Centercode = "\uf380";
        public static string Chrome = "\uf268";
        public static string Cloudscale = "\uf383";
        public static string Cloudsmith = "\uf384";
        public static string Cloudversify = "\uf385";
        public static string Codepen = "\uf1cb";
        public static string Codiepie = "\uf284";
        public static string Connectdevelop = "\uf20e";
        public static string Contao = "\uf26d";
        public static string Cpanel = "\uf388";
        public static string Creative_Commons = "\uf25e";
        public static string Creative_Commons_By = "\uf4e7";
        public static string Creative_Commons_Nc = "\uf4e8";
        public static string Creative_Commons_Nc_Eu = "\uf4e9";
        public static string Creative_Commons_Nc_Jp = "\uf4ea";
        public static string Creative_Commons_Nd = "\uf4eb";
        public static string Creative_Commons_Pd = "\uf4ec";
        public static string Creative_Commons_Pd_Alt = "\uf4ed";
        public static string Creative_Commons_Remix = "\uf4ee";
        public static string Creative_Commons_Sa = "\uf4ef";
        public static string Creative_Commons_Sampling = "\uf4f0";
        public static string Creative_Commons_Sampling_Plus = "\uf4f1";
        public static string Creative_Commons_Share = "\uf4f2";
        public static string Creative_Commons_Zero = "\uf4f3";
        public static string Critical_Role = "\uf6c9";
        public static string Css3 = "\uf13c";
        public static string Css3_Alt = "\uf38b";
        public static string Cuttlefish = "\uf38c";
        public static string D_And_D = "\uf38d";
        public static string Dashcube = "\uf210";
        public static string Delicious = "\uf1a5";
        public static string Deploydog = "\uf38e";
        public static string Deskpro = "\uf38f";
        public static string Dev = "\uf6cc";
        public static string Deviantart = "\uf1bd";
        public static string Digg = "\uf1a6";
        public static string Digital_Ocean = "\uf391";
        public static string Discord = "\uf392";
        public static string Discourse = "\uf393";
        public static string Dochub = "\uf394";
        public static string Docker = "\uf395";
        public static string Draft2digital = "\uf396";
        public static string Dribbble = "\uf17d";
        public static string Dribbble_Square = "\uf397";
        public static string Dropbox = "\uf16b";
        public static string Drupal = "\uf1a9";
        public static string Dyalog = "\uf399";
        public static string Earlybirds = "\uf39a";
        public static string Ebay = "\uf4f4";
        public static string Edge = "\uf282";
        public static string Elementor = "\uf430";
        public static string Ello = "\uf5f1";
        public static string Ember = "\uf423";
        public static string Empire = "\uf1d1";
        public static string Envira = "\uf299";
        public static string Erlang = "\uf39d";
        public static string Ethereum = "\uf42e";
        public static string Etsy = "\uf2d7";
        public static string Expeditedssl = "\uf23e";
        public static string Facebook = "\uf09a";
        public static string Facebook_F = "\uf39e";
        public static string Facebook_Messenger = "\uf39f";
        public static string Facebook_Square = "\uf082";
        public static string Fantasy_Flight_Games = "\uf6dc";
        public static string Firefox = "\uf269";
        public static string First_Order = "\uf2b0";
        public static string First_Order_Alt = "\uf50a";
        public static string Firstdraft = "\uf3a1";
        public static string Flickr = "\uf16e";
        public static string Flipboard = "\uf44d";
        public static string Fly = "\uf417";
        public static string Font_Awesome = "\uf2b4";
        public static string Font_Awesome_Alt = "\uf35c";
        public static string Font_Awesome_Flag = "\uf425";
        public static string Font_Awesome_Logo_Full = "\uf4e6";
        public static string Fonticons = "\uf280";
        public static string Fonticons_Fi = "\uf3a2";
        public static string Fort_Awesome = "\uf286";
        public static string Fort_Awesome_Alt = "\uf3a3";
        public static string Forumbee = "\uf211";
        public static string Foursquare = "\uf180";
        public static string Free_Code_Camp = "\uf2c5";
        public static string Freebsd = "\uf3a4";
        public static string Fulcrum = "\uf50b";
        public static string Galactic_Republic = "\uf50c";
        public static string Galactic_Senate = "\uf50d";
        public static string Get_Pocket = "\uf265";
        public static string Gg = "\uf260";
        public static string Gg_Circle = "\uf261";
        public static string Git = "\uf1d3";
        public static string Git_Square = "\uf1d2";
        public static string Github = "\uf09b";
        public static string Github_Alt = "\uf113";
        public static string Github_Square = "\uf092";
        public static string Gitkraken = "\uf3a6";
        public static string Gitlab = "\uf296";
        public static string Gitter = "\uf426";
        public static string Glide = "\uf2a5";
        public static string Glide_G = "\uf2a6";
        public static string Gofore = "\uf3a7";
        public static string Goodreads = "\uf3a8";
        public static string Goodreads_G = "\uf3a9";
        public static string Google = "\uf1a0";
        public static string Google_Drive = "\uf3aa";
        public static string Google_Play = "\uf3ab";
        public static string Google_Plus = "\uf2b3";
        public static string Google_Plus_G = "\uf0d5";
        public static string Google_Plus_Square = "\uf0d4";
        public static string Google_Wallet = "\uf1ee";
        public static string Gratipay = "\uf184";
        public static string Grav = "\uf2d6";
        public static string Gripfire = "\uf3ac";
        public static string Grunt = "\uf3ad";
        public static string Gulp = "\uf3ae";
        public static string Hacker_News = "\uf1d4";
        public static string Hacker_News_Square = "\uf3af";
        public static string Hackerrank = "\uf5f7";
        public static string Hips = "\uf452";
        public static string Hire_A_Helper = "\uf3b0";
        public static string Hooli = "\uf427";
        public static string Hornbill = "\uf592";
        public static string Hotjar = "\uf3b1";
        public static string Houzz = "\uf27c";
        public static string Html5 = "\uf13b";
        public static string Hubspot = "\uf3b2";
        public static string Imdb = "\uf2d8";
        public static string Instagram = "\uf16d";
        public static string Internet_Explorer = "\uf26b";
        public static string Ioxhost = "\uf208";
        public static string Itunes = "\uf3b4";
        public static string Itunes_Note = "\uf3b5";
        public static string Java = "\uf4e4";
        public static string Jedi_Order = "\uf50e";
        public static string Jenkins = "\uf3b6";
        public static string Joget = "\uf3b7";
        public static string Joomla = "\uf1aa";
        public static string Js = "\uf3b8";
        public static string Js_Square = "\uf3b9";
        public static string Jsfiddle = "\uf1cc";
        public static string Kaggle = "\uf5fa";
        public static string Keybase = "\uf4f5";
        public static string Keycdn = "\uf3ba";
        public static string Kickstarter = "\uf3bb";
        public static string Kickstarter_K = "\uf3bc";
        public static string Korvue = "\uf42f";
        public static string Laravel = "\uf3bd";
        public static string Lastfm = "\uf202";
        public static string Lastfm_Square = "\uf203";
        public static string Leanpub = "\uf212";
        public static string Less = "\uf41d";
        public static string Line = "\uf3c0";
        public static string Linkedin = "\uf08c";
        public static string Linkedin_In = "\uf0e1";
        public static string Linode = "\uf2b8";
        public static string Linux = "\uf17c";
        public static string Lyft = "\uf3c3";
        public static string Magento = "\uf3c4";
        public static string Mailchimp = "\uf59e";
        public static string Mandalorian = "\uf50f";
        public static string Markdown = "\uf60f";
        public static string Mastodon = "\uf4f6";
        public static string Maxcdn = "\uf136";
        public static string Medapps = "\uf3c6";
        public static string Medium = "\uf23a";
        public static string Medium_M = "\uf3c7";
        public static string Medrt = "\uf3c8";
        public static string Meetup = "\uf2e0";
        public static string Megaport = "\uf5a3";
        public static string Microsoft = "\uf3ca";
        public static string Mix = "\uf3cb";
        public static string Mixcloud = "\uf289";
        public static string Mizuni = "\uf3cc";
        public static string Modx = "\uf285";
        public static string Monero = "\uf3d0";
        public static string Napster = "\uf3d2";
        public static string Neos = "\uf612";
        public static string Nimblr = "\uf5a8";
        public static string Nintendo_Switch = "\uf418";
        public static string Node = "\uf419";
        public static string Node_Js = "\uf3d3";
        public static string Npm = "\uf3d4";
        public static string Ns8 = "\uf3d5";
        public static string Nutritionix = "\uf3d6";
        public static string Odnoklassniki = "\uf263";
        public static string Odnoklassniki_Square = "\uf264";
        public static string Old_Republic = "\uf510";
        public static string Opencart = "\uf23d";
        public static string Openid = "\uf19b";
        public static string Opera = "\uf26a";
        public static string Optin_Monster = "\uf23c";
        public static string Osi = "\uf41a";
        public static string Page4 = "\uf3d7";
        public static string Pagelines = "\uf18c";
        public static string Palfed = "\uf3d8";
        public static string Patreon = "\uf3d9";
        public static string Paypal = "\uf1ed";
        public static string Penny_Arcade = "\uf704";
        public static string Periscope = "\uf3da";
        public static string Phabricator = "\uf3db";
        public static string Phoenix_Framework = "\uf3dc";
        public static string Phoenix_Squadron = "\uf511";
        public static string Php = "\uf457";
        public static string Pied_Piper = "\uf2ae";
        public static string Pied_Piper_Alt = "\uf1a8";
        public static string Pied_Piper_Hat = "\uf4e5";
        public static string Pied_Piper_Pp = "\uf1a7";
        public static string Pinterest = "\uf0d2";
        public static string Pinterest_P = "\uf231";
        public static string Pinterest_Square = "\uf0d3";
        public static string Playstation = "\uf3df";
        public static string Product_Hunt = "\uf288";
        public static string Pushed = "\uf3e1";
        public static string Python = "\uf3e2";
        public static string Qq = "\uf1d6";
        public static string Quinscape = "\uf459";
        public static string Quora = "\uf2c4";
        public static string R_Project = "\uf4f7";
        public static string Ravelry = "\uf2d9";
        public static string React = "\uf41b";
        public static string Readme = "\uf4d5";
        public static string Rebel = "\uf1d0";
        public static string Red_River = "\uf3e3";
        public static string Reddit = "\uf1a1";
        public static string Reddit_Alien = "\uf281";
        public static string Reddit_Square = "\uf1a2";
        public static string Rendact = "\uf3e4";
        public static string Renren = "\uf18b";
        public static string Replyd = "\uf3e6";
        public static string Researchgate = "\uf4f8";
        public static string Resolving = "\uf3e7";
        public static string Rev = "\uf5b2";
        public static string Rocketchat = "\uf3e8";
        public static string Rockrms = "\uf3e9";
        public static string Safari = "\uf267";
        public static string Sass = "\uf41e";
        public static string Schlix = "\uf3ea";
        public static string Scribd = "\uf28a";
        public static string Searchengin = "\uf3eb";
        public static string Sellcast = "\uf2da";
        public static string Sellsy = "\uf213";
        public static string Servicestack = "\uf3ec";
        public static string Shirtsinbulk = "\uf214";
        public static string Shopware = "\uf5b5";
        public static string Simplybuilt = "\uf215";
        public static string Sistrix = "\uf3ee";
        public static string Sith = "\uf512";
        public static string Skyatlas = "\uf216";
        public static string Skype = "\uf17e";
        public static string Slack = "\uf198";
        public static string Slack_Hash = "\uf3ef";
        public static string Slideshare = "\uf1e7";
        public static string Snapchat = "\uf2ab";
        public static string Snapchat_Ghost = "\uf2ac";
        public static string Snapchat_Square = "\uf2ad";
        public static string Soundcloud = "\uf1be";
        public static string Speakap = "\uf3f3";
        public static string Spotify = "\uf1bc";
        public static string Squarespace = "\uf5be";
        public static string Stack_Exchange = "\uf18d";
        public static string Stack_Overflow = "\uf16c";
        public static string Staylinked = "\uf3f5";
        public static string Steam = "\uf1b6";
        public static string Steam_Square = "\uf1b7";
        public static string Steam_Symbol = "\uf3f6";
        public static string Sticker_Mule = "\uf3f7";
        public static string Strava = "\uf428";
        public static string Stripe = "\uf429";
        public static string Stripe_S = "\uf42a";
        public static string Studiovinari = "\uf3f8";
        public static string Stumbleupon = "\uf1a4";
        public static string Stumbleupon_Circle = "\uf1a3";
        public static string Superpowers = "\uf2dd";
        public static string Supple = "\uf3f9";
        public static string Teamspeak = "\uf4f9";
        public static string Telegram = "\uf2c6";
        public static string Telegram_Plane = "\uf3fe";
        public static string Tencent_Weibo = "\uf1d5";
        public static string The_Red_Yeti = "\uf69d";
        public static string Themeco = "\uf5c6";
        public static string Themeisle = "\uf2b2";
        public static string Trade_Federation = "\uf513";
        public static string Trello = "\uf181";
        public static string Tripadvisor = "\uf262";
        public static string Tumblr = "\uf173";
        public static string Tumblr_Square = "\uf174";
        public static string Twitch = "\uf1e8";
        public static string Twitter = "\uf099";
        public static string Twitter_Square = "\uf081";
        public static string Typo3 = "\uf42b";
        public static string Uber = "\uf402";
        public static string Uikit = "\uf403";
        public static string Uniregistry = "\uf404";
        public static string Untappd = "\uf405";
        public static string Usb = "\uf287";
        public static string Ussunnah = "\uf407";
        public static string Vaadin = "\uf408";
        public static string Viacoin = "\uf237";
        public static string Viadeo = "\uf2a9";
        public static string Viadeo_Square = "\uf2aa";
        public static string Viber = "\uf409";
        public static string Vimeo = "\uf40a";
        public static string Vimeo_Square = "\uf194";
        public static string Vimeo_V = "\uf27d";
        public static string Vine = "\uf1ca";
        public static string Vk = "\uf189";
        public static string Vnv = "\uf40b";
        public static string Vuejs = "\uf41f";
        public static string Weebly = "\uf5cc";
        public static string Weibo = "\uf18a";
        public static string Weixin = "\uf1d7";
        public static string Whatsapp = "\uf232";
        public static string Whatsapp_Square = "\uf40c";
        public static string Whmcs = "\uf40d";
        public static string Wikipedia_W = "\uf266";
        public static string Windows = "\uf17a";
        public static string Wix = "\uf5cf";
        public static string Wizards_Of_The_Coast = "\uf730";
        public static string Wolf_Pack_Battalion = "\uf514";
        public static string Wordpress = "\uf19a";
        public static string Wordpress_Simple = "\uf411";
        public static string Wpbeginner = "\uf297";
        public static string Wpexplorer = "\uf2de";
        public static string Wpforms = "\uf298";
        public static string Xbox = "\uf412";
        public static string Xing = "\uf168";
        public static string Xing_Square = "\uf169";
        public static string Y_Combinator = "\uf23b";
        public static string Yahoo = "\uf19e";
        public static string Yandex = "\uf413";
        public static string Yandex_International = "\uf414";
        public static string Yelp = "\uf1e9";
        public static string Yoast = "\uf2b1";
        public static string Youtube = "\uf167";
        public static string Youtube_Square = "\uf431";
        public static string Zhihu = "\uf63f";
    }



}

```
